# RedBorder Manager

## Master [![build status](https://gitlab.redborder.lan/web-developers/redborder-manager/badges/master/build.svg)](https://gitlab.redborder.lan/web-developers/redborder-manager/commits/master)

This is the WEB of the manager, based on Ruby on Rails

## Dependencies
`sudo yum install -y ImageMagick ImageMagick-devel sqlite-devel postgresql-devel which git`

 version of postgresql should be 9.3 or higher.
 remark : in case of centos7 environment you can install the version 9.3 using following [repo](https://yum-archive.postgresql.org/9.3/redhat/rhel-7-x86_64)

[Ruby 2.7.5 - rvm recommended](https://rvm.io/rvm/install)

## How to SETUP
1. To install the gems, run: `bundle install` into the project to download the gems
   In case of centos7 (where you installed the pgdg-93) compile the pg gem with following command and run the bundle install again : `gem install pg -- --with-pg-include=/usr/pgsql-9.3/include/ --with-pg-lib=/usr/pgsql-9.3/lib/`
3. Install the [redborder-devtools](https://github.com/redBorder/redborder-devtools) in your local machine
4. Execute the rb_get_environment.sh script to get the files : `sudo rb_get_environment.sh -i <manager_ip>` and follow the instructions on the screen
5. run `rb_grant_access -n <ip_local_machine> -m trust` in the manager followed by `chef-client`
6. Run `bin/rails` server in your local machine
7. open [localhost:3000](http://localhost:3000) in your local browser to open the manager webui

## Resolving issues
1. Its possible that after running the `rb_get_environment.sh`script with sudo, the premissions on the config directory changed to root. Change the permissions of the whole directory to your user.
2. in centos7 you my need to compile the pg gem first, before running the bundle install





