/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

// This is a manifest file that'll be compiled into application.js, which will include all the files
// listed below.
//
// Any JavaScript/Coffee file within this directory, lib/assets/javascripts, vendor/assets/javascripts,
// or vendor/assets/javascripts of plugins, if any, can be referenced here using a relative path.
//
// It's not advisable to add code directly here, but if you do, it'll appear at the bottom of the
// compiled file.
//
// WARNING: THE FIRST BLANK LINE MARKS THE END OF WHAT'S TO BE PROCESSED, ANY BLANK LINE SHOULD
// GO AFTER THE REQUIRES BELOW.
//
//= require jquery
//= require jquery_ujs
//= require jquery-ui
//= require jquery.mousewheel.js
//= require jquery.turbolinks
//= require jquery.validate
//= require jQRangeSliderMouseTouch
//= require jQRangeSliderDraggable
//= require jQRangeSliderHandle
//= require jQRangeSliderBar
//= require jQDateRangeSliderHandle
//= require jQRangeSlider
//= require turbolinks
//= require zeroclipboard
//= require d3
//= require trix
//= require topojson
//= require context-menu
//= require init
//= require_tree ./utils/
//= require modules/widgets/widgets
//= require_tree ./modules/widgets
//= require_tree ./modules/
//= require_directory .
//= require_tree ../../../lib/assets/javascripts/.
//
// This is optional (in case you have `I18n is not defined` error)
// If you want to put this line, you must put it BEFORE `i18n/translations`
//= require i18n
// Some people even need to add the extension to make it work, see https://github.com/fnando/i18n-js/issues/283
//= require i18n.js
//
// This is a must
//= require i18n/translations

var MONTHS = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Dec"];

// Prevent Dropzone from auto discovering all elements:
// This is useful when you want to create the Dropzone programmatically later
Dropzone.autoDiscover = false;

$(document).ready(function () {
  clearInterval(rbRawInterval);
  rbRawInterval = undefined;
});

/*
 This callback capture failed AJAX request and check status and X-Logout
 header. If it's true, session was expired and we need to redirect the user
 to login page.

 We hide others modals and show another with a message.
 - Angel
 */
$(document).ajaxError(function( event, xhr, settings ) {
  if (xhr.status == 401 && xhr.getResponseHeader("X-Logout") === 'true' &&
      !$('body').hasClass('sessions')) {

    var message = '',
        others_modals = $('.modal.fade.in'),
        timeout;

    // Hide others modals
    if (others_modals.length > 0 && others_modals.find('form').length > 0) {
      message = I18n.t('expired_html')
      timeout = 2500;
    } else {
      message = I18n.t('expired2')
      timeout = 1500;
    }

    others_modals.modal('toggle');

    var html = '<div class="modal-header"> \
                  <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">' + I18n.t('close') + '</span></button> \
                  <h3 class="modal-title" id="select_widget_type_label">' + I18n.t('timeout') + '</h3> \
                </div> \
                <div class="modal-body"> \
                  '+ message +' \
                </div> \
                <div class="modal-footer"> \
                </div>';
    $('#default_modal .modal-content').html(html);
    $('#default_modal').modal('toggle');

    setTimeout(function(){
      location.href = '/users/login';
    }, timeout);
  }
});

// Events
$(window).resize(function () {
  if ($('body.traffics.index').length !== 0 || $('body.events.index').length !== 0) {
    if (window.rb !== undefined && window.rb.resize !== undefined) {
      window.rb.resize();
    }
  }

  if ($('body.tops').length !== 0 || $('body.cardinality').length !== 0 ||
    $('body.monitor.index').length !== 0 || $('body.comparative').length !== 0 ) {
    var activeTab = $('.tab-pane.active').attr('id')
    window['rb_' + activeTab].resize();
  }
});

function blockWebUI() {
  $.blockUI({
    css: {
      border: 'none',
      padding: '10px',
      backgroundColor: '#000',
      '-webkit-border-radius': '10px',
      '-moz-border-radius': '10px',
      'border-radius': '10px',
      opacity: .7,
      color: '#fff'
    },
    overlayCSS:  {
        backgroundColor: '#313131',
        opacity:         0.3,
        cursor:          'wait'
    }
  });
}

function refreshNotification() {
  $.ajax({
    url: '/notifications/reload',
    type: 'GET',
    dataType: 'script',
    global: false,
    cache: false
  });
}

function sort_unique(arr) {
  arr = arr.sort(function (a, b) { return a*1 - b*1; });
  var ret = [arr[0]];
  for (var i = 1; i < arr.length; i++) { // start loop at 1 as element 0 can never be a duplicate
      if (arr[i-1] !== arr[i]) {
          ret.push(arr[i]);
      }
  }
  return ret;
}

function load_file_style(){
  $('input[type="file"]').filestyle({
    icon: false,
    buttonBefore: true
  });
}

// Time helper
function format_time(time, options) {
  var options = options || {};

  var html = time.getFullYear() + '/' + time.getMonth() + '/' + time.getDate() + ' at ';
  // Bold time
  if(options.bold === true) {
    html += '<b>' + padding_time(time.getHours()) + ':' + padding_time(time.getMinutes()) + '</b>';
  } else {
    html += padding_time(time.getHours()) + ':' + padding_time(time.getMinutes());
  }
  // Return HTML
  return html;
}

// Padding time with a 0 if the number if less than 10
function padding_time(value) {
  return value < 10 ? ('0' + value) : value;
}

$(document).on("click", "a#show-help", function(event){
  event.preventDefault();

  var intro = introJs();
  intro.setOption("exitOnOverlayClick", "true");

  /*intro.onafterchange(function(targetElement) {

    var body = $('body');

    if(body.hasClass('dashboards') && $(targetElement).attr('data-step') == '1'){
      $(targetElement).find("ul.dropdown-menu").css("display", "block");
      $(targetElement).find("ul.dropdown-menu").css("z-index", "9999998");
    } else if(body.hasClass('dashboards') && $(targetElement).attr('data-step') == '2'){
      $(targetElement).parent().css("z-index", "9999999 !important")
    }

  });

  intro.onbeforechange(function(targetElement) {

    var body = $('body');

    if(body.hasClass('dashboards') && $(targetElement).attr('data-step') == '3'){
      $("#dashboard-selector .dropdown-menu").removeAttr("style");
    }

  });*/

  intro.start();

});

/*
 * Listen to chosen to hide the selector when the user click in an option
 */
$(document).on('click', '.chosen-container-single .chosen-results li', function(e){
  $(this).parents('.chosen-container-single').removeClass('chosen-container-active chosen-with-drop');
});

/*
 * Listen apply namespaces click.
 */
$(document).on('click', 'a.apply-namespaces', function(e){
  // Prevent, we will send the data over POST
  e.preventDefault();
  var link = $(this).attr('href');
  var actives = [];

  $('.namespace-menu .dropdown-menu .namespaces .namespace').each(function(i){
    var check = $(this).find('input');

    if(check.length > 0 && check.prop('checked') && check.data('id') != 'all'){
      actives.push(check.data('id'));
    }
  });

  // Change apply button
  $(this).html('<i class="fa fa-spinner fa-pulse"></i>');

  // Set the data
  $.ajax({
    url: '/namespaces',
    type: 'POST',
    dataType: 'json',
    data: {
      namespaces: actives
    },
    success: function (data) {
      // Reload the page
      location.reload();
    },
    fail: function(data) {
      $(this).html('Apply');
    }
  });
});

/*
 * Check all namespace checkbox (less 'all') to check or uncheck All checkbox.
 */
$(document).on('click', '.namespace-menu input:not(#namespace_all)', function(e){
  if($(this).prop('checked')){
    // We must check all namespaces
    all_check = true;
    $('.namespace-menu input[type="checkbox"]:not(#namespace_all)').each(function(i){
      if(!$(this).prop('checked')){
        all_check = false;
      }
    })
    if(all_check){
      $('#namespace_all').prop('checked', true);
    }
  } else {
    // We must uncheck namespaces
    $('#namespace_all').prop('checked', false);
  }
});

/*
 * Listen all checkbox click.
 */
$(document).on('click', '#namespace_all', function(e){
  if($(this).prop('checked')){
    // We must check all namespaces
    $('.namespace-menu .dropdown-menu li input').prop('checked', true);
  } else {
    // We must uncheck namespaces
    $('.namespace-menu .dropdown-menu li input').prop('checked', false);
  }
});

/*
 * Search on namespaces
 */
$(document).on('keyup', "#namespace-search", function(e){
  var search = $(this).val();

  if (search.length > 0){
    // User type some, hide no coincidences
    $('.namespace-menu .namespaces .namespace').each(function(i){
      if($(this).data('namespace-name').indexOf(search) > -1){
        $(this).show();
      } else {
        $(this).hide();
      }
    });
  } else {
    // Empty input
    $('.namespace-menu .namespaces .namespace').show();
  }
});

/* Clipit depending on flash
function clipit(element) {
  if (detectFlashSupport()) {
    var clip = new ZeroClipboard(element);
    clip.on('ready', function(event) {
      clip.on('copy', function(event){
        var clipboard = event.clipboardData;
        var text = $(event.target).data('clipboard-text');
        clipboard.setData("text/plain", text);
      });

      clip.on('aftercopy', function(event) {
        $('span.dropdown.open').removeClass('open');
        redBorder.modals.showModalWith(
          'Copied',
          'The value has been copied to the clipboard',
          redBorder.modals.dismissButton('Back'),
          '#default_modal');
      });
    });
    // Set this element as clipped
    element.data('clipped', true);
  } else {
    $('a[data-clipboard-text]').remove();
  }
}*/

function clipit(element) {
  if (ClipboardJS.isSupported()) {

    //clipboard fetches all elements that matches the selector to add a event listener
    var clipboard = new ClipboardJS('.js-copy');

  } else {
    $('a[data-clipboard-text]').remove();
  }
}

$(document).on("page:before-change", function(){
  // Destroy clipboard clients on turbolinks page change
  ZeroClipboard.destroy()
});

$(document).on("page:change", function(){
  // Reenable them after the change
  add_clipit_function();
});

$(document).on('click', 'a[data-clipboard-text]', function(event){
  event.preventDefault();
});

function add_clipit_function() {
  $('a[data-clipboard-text]').each(function () {
    if ($(this).data('clipped') === undefined || $(this).data('clipped') === false) {
      clipit($(this))
    }
  });
}

function detectFlashSupport() {
  var hasFlash = false;
  if (typeof ActiveXObject === "function") {
    try {
      if (new ActiveXObject("ShockwaveFlash.ShockwaveFlash")) {
        hasFlash = true;
      }
    } catch (error) {}
  }
  if (!hasFlash && navigator.mimeTypes["application/x-shockwave-flash"]) {
    hasFlash = true;
  }
  return hasFlash;
};

/*
* Copy @text to clipboard using Flash
*/
function copy_to_clipboard(button, text){
  if (detectFlashSupport()){
      var client = new ZeroClipboard(button);
      client.on('ready', function(event) {
        client.on('copy', function(event) {
          var clipboard = event.clipboardData;
          clipboard.setData("text/plain", text);
        });

        // callback triggered on successful copying
        client.on('aftercopy', function(event) {
          alert('Copied to clipboard');
        });
    });

    // In case of error - such as Flash not being available
    client.on('error', function() {
      ZeroClipboard.destroy();
      alert('Error. Could not copy to clipboard');
    });
  }
}

function post_to_url(path, params, method) {
  method = method || "post";

  var form = document.createElement("form");
  form.setAttribute("method", method);
  form.setAttribute("action", path);

  for(var key in params) {
    if (params.hasOwnProperty(key)) {
      var hiddenField = document.createElement("input");
      hiddenField.setAttribute("type", "hidden");
      hiddenField.setAttribute("name", key);

      var value = params[key];
      if (typeof value === "object") {
        hiddenField.setAttribute("value", JSON.stringify(value));
      } else if (typeof value === "string") {
        hiddenField.setAttribute("value", value);
      } else if (typeof value === "boolean") {
        hiddenField.setAttribute("value", value);
      };

      form.appendChild(hiddenField);
    };
  };

  document.body.appendChild(form);
  form.submit();
};

$(document).on('click', '.search-content-add', function(e) {
  var parent = this.closest('.combination')
  if (parent !== undefined && parent !== null) {
    var where = '[data-serie-position=' + parent.getAttribute('data-serie-position') +'] #search .rules',
        count = parent.getAttribute('data-serie-position'),
        module_active = $("[data-serie-position='" + count.toString() +"'] #widget_module").val();

    search_hash = redBorder['search_hash_' + module_active];
    window['widget_product_type_' + module_active](null);
    rule.add(where)
  } else {
    rule.add();
  }
});
$(document).on('click', '.search-content-remove', function(e) {
  rule.remove(this);
});

$(document).on('click.dropdown.data-api', '.dropdown-submenu > a', function (event) {
  event.preventDefault();
});

$(document).on('click.dropdown', '.dropdown-menu', function (e) {
  e.stopPropagation();
});

$('.dropdown-toggle').click(function(e) {
  e.preventDefault();
  setTimeout($.proxy(function() {
    if ('ontouchstart' in document.documentElement) {
      $(this).siblings('.dropdown-backdrop').off().remove();
    }
  }, this), 0);
});

$(document).on('click', '.group-accordion-toggle a.pull-right', function(e) {
  e.stopPropagation();
});

$(document).on('focus', '.form-error', function(e) {
    $(this).removeClass('form-error');
});

// Disable the request to disabled anchors
$(document).on('click', 'a.disabled', function(event){

  event.preventDefault();

  return false;
});

$(document).on('shown.bs.tab', '.nav-tabs a[data-toggle="tab"]', function() {
  var tabId = $(this).parents('li').attr('id'),
      maps = ['coordinates_map', 'src_map', 'dst_map', 'public_ip_map'];

  try {
    if (maps.indexOf(tabId) !== -1 && !window['rb_' + tabId].wasInitialize()) {
      window['rb_' + tabId].initialize();
    }
  } catch (err) {
    console.error("Couldn't load map for tab " + tabId + ". " + err);
  }
});

$(document).on('click', '.graph_arrow', function (e) {
  var direction = $(this).data("direction"),
      type = $(this).data("type"),
      product = $(this).data("product"),
      remove_from = $(this).data("direction") === "left" ? "right" : "left",
      forecast = $(this).data('forecast'),
      enabled = $(this).attr('data-enabled'),
      rangemilis = parseInt($(this).siblings(".graph_main").data("range")),
      granularitymilis = parseInt($(this).siblings(".graph_main").data("granularity")),
      granularity = $(this).siblings(".graph_main").data("granularity-sym"),
      end_time_milsec, start_time_milsec, end_time, start_time,
      base_url, rbvar;

  function updateURLs () {
    $('#tab_' + tab + ' tbody tr td span a[data-remote]').each(function (w) {
      $(this).attr("href", updateURLParameter($(this).attr("href"), "start_time", Math.round(window[rbvar].currentDomain()[0] / 1000)));
      $(this).attr("href", updateURLParameter($(this).attr("href"), "end_time", Math.round(window[rbvar].currentDomain()[1] / 1000)));
    });
  }

  function load_total_graph () {
    $.ajax({
      url: base_url + '/get_serie/' + tab,
      type: 'GET',
      dataType: 'json',
      data: {
        start_time: start_time,
        end_time: "direction" === "left" ? end_time : end_time + granularitymilis / 1000,
        granularity: granularity,
        total: true
      },
      success: function (data) {
        loaded = loaded + 1;

        if (data.length > 0) {
          hash = {
            name: "Total",
            data: data
          };

          dataserie.push(hash);

          if (loaded === elemsnum) {
            if (direction === "left") {
              window[rbvar].forceDomain([new Date(start_time * 1000), -1]);
            } else {
              window[rbvar].forceDomain([-1, right_limit]);
              $.unblockUI();
            }
            window[rbvar].append(dataserie, remove_from, updateURLs);
          }
        }
      }
    });
  }

  function load_total_filtered_graph () {
    $.ajax({
      url: base_url + '/get_serie/' + tab,
      type: 'GET',
      dataType: 'json',
      data: {
        start_time: start_time,
        end_time: "direction" === "left" ? end_time : end_time + granularitymilis / 1000,
        granularity: granularity
      },
      success: function (data) {
        loaded = loaded + 1;

        if (data.length > 0) {
          hash = {
            name: "Total_Filtered",
            data: data
          };

          dataserie.push(hash);

          if (loaded === elemsnum) {
            if (direction === "left") {
              window[rbvar].forceDomain([new Date(start_time * 1000), -1]);
            } else {
              window[rbvar].forceDomain([-1, right_limit]);
              $.unblockUI();
            }
            window[rbvar].append(dataserie, remove_from, updateURLs);
          }
        }
      }
    });
  }

  if (enabled === "false") {
    return;
  }

  if (type === "cardinality" || type === "cardinality-group") {
    base_url = '/' + product + '/cardinality';
  } else {
    base_url = window['base_url_' + product](product);
  }

  if (type === "tops" || type === "cardinality" || type === "cardinality-group") {
    var tab = $(this).parents("div.tab-pane").attr("id").substr(4);
    rbvar = "rb_" + tab;
  } else {
    rbvar = "rb";
  }

  if (direction === "left") {
    end_time_milsec = window[rbvar].currentDomain()[0] + granularitymilis;
    start_time_milsec = end_time_milsec - rangemilis;
    end_time = Math.round(end_time_milsec / 1000);
    start_time = Math.round((Math.floor(start_time_milsec / granularitymilis) * granularitymilis) / 1000);
  } else {
    start_time_milsec = window[rbvar].currentDomain()[1];
    end_time_milsec = start_time_milsec + rangemilis;
    end_time = Math.round((Math.floor(end_time_milsec / granularitymilis) * granularitymilis) / 1000);
    start_time = Math.round(start_time_milsec / 1000);

    if(end_time * 1000 > redBorder.timeNow.getTime()){
      end_time = Math.round(redBorder.timeNow.getTime() / 1000);
    }

    blockWebUI();
  }

  if (forecast === false && (end_time_milsec + rangemilis) > redBorder.timeNow.getTime() && direction === "right") {
    $('.graph_arrow[data-direction="right"]').attr('data-enabled', "false");
  } else {
    $('.graph_arrow[data-direction="right"]').attr('data-enabled', "true");
  }

  if (window[rbvar]._usesMaxDomain() === false) {
    return;
  }

  if (type === "tops" || type === "cardinality-group") {
    var elements = $('.tab-pane.active table tbody tr td.serie span a.load'),
      elemsnum = elements.length + 2, dataserie = [], loaded = 0, has_total = false, has_total_filtered = false;

    window[rbvar].elements.forEach(function (elem) {
      if (elem.name === "Total")  has_total = true;
      if (elem.name === "Total_Filtered")  has_total_filtered = true;
    });

    if (has_total) load_total_graph();
    else loaded++;

    if (has_total_filtered) load_total_filtered_graph();
    else loaded++;

    elements.each(function (serie) {
      var value = $(this).text(),
        param_data = {}, right_limit = -1;

      param_data = window['render_elements_' + product]($(this), start_time, end_time, granularitymilis, tab, granularity, value, type);
      if (type === "cardinality-group") {
        param_data["cardinality_forecast"] = true;
      }

      $.ajax({
        url: base_url + '/get_serie/' + tab,
        type: 'GET',
        dataType: 'json',
        data: param_data,
        success: function (data) {
          if (data.length > 0) {
            hash = {
              name: value,
              data: data
            };

            dataserie.push(hash);

            if (new Date(data[0].timestamp) > right_limit) {
              right_limit = new Date(data[0].timestamp);
            }
          }

          loaded = loaded + 1;

          if (loaded === elemsnum) {
            if (direction === "left") {
              window[rbvar].forceDomain([new Date(start_time * 1000), new Date(Math.round(window[rbvar].currentDomain()[0] / 1000) * 1000)]);
            } else {
              window[rbvar].forceDomain([new Date(Math.round(window[rbvar].currentDomain()[1] / 1000) * 1000), new Date(end_time * 1000)]);
              $.unblockUI();
            }
            window[rbvar].append(dataserie, remove_from, updateURLs);
            if (type === "tops") {
              window[rbvar].semitop.selectAll("circle").attr("cy", -999999);
              window[rbvar].semitop.selectAll("circle[class^='rb-point-']").remove();
            }
          }
        }
      });
    });
  } else if (type === "cardinality") {
    $.ajax({
      url: base_url + '/get_serie/' + tab,
      type: 'GET',
      dataType: 'json',
      data: {
        start_time: start_time,
        end_time: "direction" === "left" ? end_time : end_time + granularitymilis / 1000,
        granularity: granularity,
        cardinality_forecast: true
      },
      success: function (data) {
        if (direction === "left") {
          window[rbvar].forceDomain([new Date(start_time * 1000), new Date(Math.round(window[rbvar].currentDomain()[0] / 1000) * 1000)]);
        } else {
          window[rbvar].forceDomain([new Date(Math.round(window[rbvar].currentDomain()[1] / 1000) * 1000), new Date(end_time * 1000)]);
          $.unblockUI();
        }

        window[rbvar].append([{
          name: "Total",
          data: data
        }], remove_from);
      }
    });
  } else {
    $.ajax({
      url: base_url + '/get_serie/raw',
      type: 'GET',
      dataType: 'json',
      data: {
        start_time: start_time,
        end_time: "direction" === "left" ? end_time : end_time + granularitymilis / 1000,
        granularity: granularity
      },
      success: function (data) {
        if (direction === "left") {
          rb.forceDomain([new Date(start_time * 1000), new Date(Math.round(window[rbvar].currentDomain()[0] / 1000) * 1000)]);
        } else {
          rb.forceDomain([new Date(Math.round(window[rbvar].currentDomain()[1] / 1000) * 1000), new Date(end_time * 1000)]);
          $.unblockUI();
        }

        rb.append([{
          name: "Total",
          data: data
        }], remove_from);

        rb.semitop.selectAll("circle").attr("cy", -999999)
        rb.semitop.selectAll("circle[class^='rb-point-']").remove();
      }
    });
  }

});

function create_scatterplot_filter_dropdown(header, ip) {
  return (
    '<span class="dropdown filter">' +
    '  <a data-toggle="dropdown" class="dropdown-toggle" href="#">' +
    '    <i class="fa fa-caret-down"></i>' +
    '  </a>' +
    '  <ul class="dropdown-menu">' +
    '    <li><a class="scatterplot-filter" data-header="' +
    header +
    '" data-ip="' +
    ip +
    '" href="#"><i class="fa fa-plus"></i>' + I18n.t("redborder.commons.common.tops_table.filter")
+ '</a></li>' +
    '  </ul>' +
    '</span>'
  );
}

function export_element_as_image(event, widgetid, name, ele) {
  event.preventDefault();
  var isTitle = false;
  var el = (ele !== undefined) ? document.getElementById(ele) : 
    (widgetid === undefined) ? document.querySelectorAll('[id^="tops_"]')[0] : 
    document.querySelector('[data-widget-id="' + widgetid + '"]');
  var fileName = (name === undefined) ? document.title : name;
  isTitle = (name === undefined) ? true : false ;
  fileName = fileName.toLowerCase().split('|')[0].replace(/\s/g, '_')
  fileName = fileName.replace(/[^a-zA-Z0-9_]/g, "");
  fileName = fileName.replace(/\_{2,}/g, '_')
  fileName = isTitle == true ? fileName.slice(0, fileName.length-1) : fileName
  html2canvas(el).then(function(canvas) {
    var link = document.createElement("a");
    document.body.appendChild(link);
    link.download = fileName;
    link.href = canvas.toDataURL();
    link.target = '_blank';
    link.click();
  });
}

function hook_scatterplot_filter(){
    var form_wan_ip = $("#form_scatterplot_filter_wan_ip");
    var form_lan_ip = $("#form_scatterplot_filter_lan_ip");
    var input_wan_ip = $("#input_scatterplot_filter_wan_ip")
    var input_lan_ip = $("#input_scatterplot_filter_lan_ip")

    $('.scatterplot_lan_ip, .scatterplot_wan_ip').each(function () {
      var header = $(this).data('header');
      var ip = $(this).data('ip');
      if ($(this).find('.fa-plus').length === 0) {
        $(this).text() !== I18n.t("redborder.commons.common.tops_table.filter")
          ? $(this).append(create_scatterplot_filter_dropdown(header, ip))
          : void 0;
      }
    });

    $('.scatterplot-filter').click(function () {
      var dataIp = $(this).data('ip');
      var header = $(this).data('header');
      if (header === "LAN IP") {
        input_lan_ip.val(dataIp);
        form_lan_ip.submit();
      } else if (header === "WAN IP") {
        input_wan_ip.val(dataIp);
        form_wan_ip.submit();
      }
    });
}

function download_table_as_csv(table_id, max_rows, tab_name, path_name) {
  var separator = ","
  var rows = document.querySelectorAll('table#' + table_id + ' tr');
  var numRows = Math.min(max_rows, rows.length);
  var csv = [];
  for (var i = 0; i < numRows + 1; i++) {
      if(rows[i]){
        var row = [], cols = rows[i].querySelectorAll('td, th');
        for (var j = 0; j < cols.length; j++) {
          var firstChild = cols[j].firstChild;
          var firstElementText = firstChild.textContent;
          var data = firstElementText.replace(/(\r\n|\n|\r)/gm, '').replace(/(\s\s)/gm, ' ');
          data = data.replace(/"/g, '""');
          row.push('"' + data.trim() + '"');
        }
        csv.push(row.join(separator));
      }
  }
  var csv_string = csv.join('\n');
  var currentDate = new Date();
  var formattedDate = currentDate.toISOString().replace(/[-:.T]/g, '');
  var filename = formattedDate.split('Z')[0] + '-' + path_name + '_' + tab_name + '.csv';
  var link = document.createElement('a');
  link.style.display = 'none';
  link.setAttribute('target', '_blank');
  link.setAttribute('href', 'data:text/csv;charset=utf-8,' + encodeURIComponent(csv_string));
  link.setAttribute('download', filename);
  document.body.appendChild(link);
  link.click();
  document.body.removeChild(link);
}

function export_comparative_to_csv(x, tab) {
  var name = document.getElementById(tab.split("_")[1]).innerText
  document.getElementById("export_to_csv_comparative").innerText = I18n.t('disable');
  document.getElementById("export_to_csv_comparative").disabled = true;
  var load_more = document.getElementsByClassName('tops_offset ' + tab.split("_")[1] + ' btn');
  tab = 'tab-table-' + tab.split("_")[1];
  var intervalId = setInterval(function() {
       var rows = document.getElementById(tab).rows.length;
       if (rows >= x || load_more.length == 0) {
           clearInterval(intervalId);
           download_table_as_csv(tab, x, name, "LocationComparative");
           redBorder.modals.hideModals();
       } else {
           load_more[0].click();
       }
   }, 100);
 }

function export_movements_to_csv(x, tab) {
  var name = tab.charAt(0).toUpperCase() + tab.slice(1)
  document.getElementById("export_to_csv_movements").innerText = I18n.t('disable');
  document.getElementById("export_to_csv_movements").disabled = true;
  download_table_as_csv("tab-movements-" + tab, x, name, "LocationMovements");
  redBorder.modals.hideModals();
}

function show_modal_comparative_export_to_csv() {
  var tabElements = document.querySelectorAll('[data-group="comparative_tab"]');
  var activeTab;
  for (var i = 0; i < tabElements.length; i++) {
      if (tabElements[i].classList.contains('active')) {
          activeTab = tabElements[i];
          break;
      }
  }

  var sectionListHTML = '';
  for (var j = 0; j < tabElements.length; j++) {
      var element = tabElements[j];
      var value = element.getElementsByTagName("a")[1].href.split("#")[1];
      var text = element.textContent.trim();
      var selected = element === activeTab ? 'selected' : '';
      sectionListHTML += '<option value="' + value + '" ' + selected + '>' + text + '</option>';
  }

  var modalContent = '<label for="sectionSelector">Tab:</label>' +
      '<select class="form-control" id="comparative_tabs">' + sectionListHTML + '</select>' +
      '<br>' +
      '<label for="limit">Limit:</label>' +
      '<input class="form-control" type="number" id="rowLimit" min="1" value="10">';

  var modalFooter = '<button class="btn btn-success" id="export_to_csv_comparative" onclick="export_comparative_to_csv(document.getElementById(\'rowLimit\').value, document.getElementById(\'comparative_tabs\').value)">' + I18n.t('export') + '</button>' +
      redBorder.modals.dismissButton(I18n.t('cancel'));

  redBorder.modals.showModalWith(
      I18n.t('export_csv_comparative'),
      modalContent,
      modalFooter,
      '#default_modal'
  );
}

function show_modal_movements_export_to_csv() {
  var tabElements = document.getElementsByClassName("tab-selector")
  var activeTab;
  for (var i = 0; i < tabElements.length; i++) {
      console.log(tabElements)
      if (tabElements[i].classList.contains('active')) {
          activeTab = tabElements[i];
          break;
      }
  }
  for (var j = 0; j < tabElements.length; j++) {
    var element = tabElements[j];
    var text = element.textContent.trim();
    var selected = element === activeTab ? 'selected' : '';
    sectionListHTML += '<option value="' + element.id + '" ' + selected + '>' + text + '</option>';
  }

  var modalContent = '<label for="sectionSelector">Tab:</label>' +
      '<select class="form-control" id="movements_tabs">' + sectionListHTML + '</select>' +
      '<br>' +
      '<label for="limit">Limit:</label>' +
      '<input class="form-control" type="number" id="rowLimit" min="1" value="10">';

  var modalFooter = '<button class="btn btn-success" id="export_to_csv_movements" onclick="export_movements_to_csv(document.getElementById(\'rowLimit\').value, document.getElementById(\'movements_tabs\').value)">' + I18n.t('export') + '</button>' +
      redBorder.modals.dismissButton(I18n.t('cancel'));

  redBorder.modals.showModalWith(
      I18n.t('export_csv_movements'),
      modalContent,
      modalFooter,
      '#default_modal'
  );
}

$(document).on('click', '#scatterplot', function(){
  hook_scatterplot_filter()
})

function fix_outliers(data, type){
  for (var i = 0; i < data[type].length; i++) {
    if (type === "anomalies" && data[type][i].expected < 0) {
      data[type][i].expected = 0;
    }
    if (type === "predicted" && data[type][i].forecast < 0) {
      data[type][i].forecast = 0;
    }
  }
  return data;
};

function get_outliers_url(){
  const urlParts = new URL(location.href);
  const firstPathSegment = urlParts.pathname.split('/')[1];
  return urlParts.protocol + '//' + urlParts.hostname + '/' + firstPathSegment;
}

$(document).on('click', '.graph_outliers', function (e) {
  var type = $(this).data("type"),
      product = $(this).data("product"),
      serie = $(this).data("serie"),
      rangemilis = parseInt($(".graph_main").data("range")),
      granularitymilis = parseInt($(".graph_main").data("granularity")),
      granularity = $(".graph_main").data("granularity-sym"),
      end_time_milsec, start_time_milsec, end_time, start_time,
      rbvar;

  if (type === "tops") {
    var tab = $(this).parents("div.tab-pane").attr("id").substr(4);
    rbvar = "rb_" + tab;
  } else {
    rbvar = "rb";
  }

  start_time_milsec = window[rbvar].currentDomain()[0];
  end_time_milsec = window[rbvar].currentDomain()[1];
  end_time = Math.round(end_time_milsec / 1000);
  start_time = Math.round(start_time_milsec / 1000);

  if (type === "tops") {
    var value = serie,
        param_data = {};
    param_data = window['render_elements_' + product]($(this), start_time, end_time, granularitymilis, tab, granularity, value, type);

    $.ajax({
      url: get_outliers_url() + '/get_outliers/' + tab,
      type: 'GET',
      dataType: 'json',
      data: param_data,
      success: function (data) {
        data = JSON.parse(JSON.stringify(data));
        if(data.status !== 'success'){
          const error = 'Error while calculating outliers, something went wrong....'
          show_alert("danger", error);
          flash_message.push({type: 'error', message: error});
          flash();
          $.unblockUI();
          return
        }
        if(data.predicted.length == 0){
          flash_message.push({type: 'warning', message: "Review the input data, could not draw predicted graph, there is no data from the server..."});
          flash();
          $.unblockUI();
          return
        }
        if (data.anomalies.length >= 0) {
          if(data.anomalies.length == 0){
            flash_message.push({type: 'success', message: I18n.t('outliers')});
            flash();
          }
          data.anomalies = fix_outliers(data, "anomalies").anomalies
          data.predicted = fix_outliers(data, "predicted").predicted
          if (value === "N/A") value = "";
          window[rbvar].add_points({
            name: value,
            data: data.anomalies
          });
          window[rbvar].add({
            name: value+"_predicted",
            dashed: true,
            type: "line",
            color: window[rbvar].getColor(value),
            data: data.predicted
          });
        }
        $.unblockUI();
      },
      error: function(xhr) {
        var error = $.parseJSON(xhr.responseText).error;
        flash_message.push({type: 'error', message: error});
        flash();
        $.unblockUI();
      }
    });

    $('.dropdown').removeClass('open');
  } else {
    $.ajax({
      url: product + '/get_outliers/raw',
      type: 'GET',
      dataType: 'json',
      data: {
        start_time: start_time,
        end_time: end_time,
        granularity: granularity
      },
      success: function (data) {
        if (data.length >= 0) {
          rb.add_points({
            name: "Total",
            data: data
          });
        } else {
          flash_message.push({type: 'success', message: I18n.t('outliers')});
          flash();
        }
        $.unblockUI();
      },
      error: function(xhr) {
        var error = $.parseJSON(xhr.responseText).error;
        flash_message.push({type: 'error', message: error});
        flash();
        $.unblockUI();
      }
    });

    $('#options').removeClass('open');
  }
});

/*
 * Update an url with the new param and paramVal
 */
function updateURLParameter(url, param, paramVal) {
    var TheAnchor = null;
    var newAdditionalURL = "";
    var tempArray = url.split("?");
    var baseURL = tempArray[0];
    var additionalURL = tempArray[1];
    var temp = "";

    if (additionalURL)
    {
        var tmpAnchor = additionalURL.split("#");
        var TheParams = tmpAnchor[0];
            TheAnchor = tmpAnchor[1];
        if(TheAnchor)
            additionalURL = TheParams;

        tempArray = additionalURL.split("&");

        for (i=0; i<tempArray.length; i++)
        {
            if(tempArray[i].split('=')[0] != param)
            {
                newAdditionalURL += temp + tempArray[i];
                temp = "&";
            }
        }
    }
    else
    {
        var tmpAnchor = baseURL.split("#");
        var TheParams = tmpAnchor[0];
            TheAnchor  = tmpAnchor[1];

        if(TheParams)
            baseURL = TheParams;
    }

    if(TheAnchor)
        paramVal += "#" + TheAnchor;

    if(paramVal instanceof Array){
      var rows_txt = temp + "";

      for(var i = 0; i < paramVal.length; i++){
        rows_txt += param + '[]=' + paramVal[i] + "&";
      }
      rows_txt = rows_txt.substring(0, rows_txt.length - 1);
    } else {
      var rows_txt = temp + "" + param + "=" + paramVal;
    }

    return baseURL + "?" + newAdditionalURL + rows_txt;
}

function loadSerieOutliers(tab, value) {

  var type = $(this).data("type"),
      product = redBorder.product,
      rangemilis = parseInt($(".graph_main").data("range")),
      granularitymilis = parseInt($(".graph_main").data("granularity")),
      granularity = $(".graph_main").data("granularity-sym"),
      end_time_milsec, start_time_milsec, end_time, start_time,
      param_data = {}, right_limit = -1, rbvar;

  rbvar = "rb_" + tab;

  start_time_milsec = window[rbvar].currentDomain()[0];
  end_time_milsec = window[rbvar].currentDomain()[1];
  end_time = Math.round(end_time_milsec / 1000);
  start_time = Math.round(start_time_milsec / 1000);

  param_data = window['render_elements_' + product]($(this), start_time, end_time, granularitymilis, tab, granularity, value, type);

  $.ajax({
    url: get_outliers_url() + '/get_outliers/' + tab,
    type: 'GET',
    dataType: 'json',
    data: param_data,
    success: function (data) {
      if (data.length > 0) {
        if (value === "N/A") value = "";
        window[rbvar].add_points({
          name: value,
          data: data
        });
      }
    }
  });
}

var rbRawInterval;
var rbReloadingIndex = 0;

function reloadRaw(where) {
  var granularity = parseInt($('#graph').data("granularity")),
      go_back = granularity <= 60000 ? granularity * 5 : granularity
      start_time = Math.ceil((new Date().getTime() - go_back) / granularity) * granularity,
      end_time = Math.ceil(new Date().getTime() / granularity) * granularity,
      currentDate = new Date();

  if (rb instanceof RB.Sankey || rb.currentDomain()[1] >= new Date(currentDate.getTime() - go_back - 300000)) {
    // Get new events
    $.ajax({
      url: '/' + where + '/load_new_data/',
      type: 'GET',
      dataType: 'script',
      data: {
        start_time: Math.floor(start_time / 1000),
        end_time: Math.floor(end_time / 1000),
        reload_index: rbReloadingIndex,
        granularity: $('#graph').data("granularity-sym"),
        news: true
      }
    });
  }

  rbReloadingIndex++;
}

function reloadRawClick (where, time) {
  if (rbRawInterval !== undefined) {
    clearInterval(rbRawInterval);
    rbRawInterval = undefined;

    $('li.reload a').text(I18n.t('stopped'));
    $('li.reload-option a').text(I18n.t('start_reloading'));
  } else {
    $('li.reload').show();
    $('li.reload-option a').text(I18n.t('stop_reloading'));
    window['reloadRawInterval' + where.toUpperCase()](time);
  }
}

String.prototype.capitalize = function() {
  return this.charAt(0).toUpperCase() + this.slice(1);
}

$(document).on('click', '.table .selectable-serie', function(e) {
  if (e.shiftKey) {
    var selectedSerie = redBorder.lastSerieSelected;

    if (selectedSerie !== undefined) {
      var selectedSeriesIndex = selectedSerie.index();
      var myIndex = $(this).index();
      var firstElement, lastElement;

      if (selectedSeriesIndex < myIndex) {
        firstElement = selectedSerie;
        lastElement = $(this);
      } else if (selectedSeriesIndex > myIndex) {
        firstElement = $(this);
        lastElement = selectedSerie;
      }

      if (firstElement !== undefined) {
        var series = firstElement.nextUntil(lastElement);
        series.click();
      }
    }
  }

  if( $(e.target).is('a') ){
    e.stopPropagation();
  } else {
    var row = $(this);
    var tab = $(this).parents('.active');
    redBorder.lastSerieSelected = $(this);

    row.toggleClass('selected');

    if ( row.hasClass('selected') ) {
      row.find("td").css('background-color', '#FFC');
    } else {
      row.find("td").css('background-color', '');
    }

    total = tab.find('.table').find("tr.selected").length

    if (total > 0) {
      tab.find('div.filter-multiple').removeClass('filter-hide');
      tab.find('div.filter-multiple').addClass('filter-show');
      tab.find('.table-info table thead .total-selected-header').html(I18n.t('selected') + total + I18n.t('rows'))
    } else {
      tab.find('div.filter-multiple').removeClass('filter-show');
      tab.find('div.filter-multiple').addClass('filter-hide');
      tab.find('.table-info table thead .total-selected-header').html(I18n.t('selected').split("(").join(""))
    }

    selected_values = filter_selected(tab.find('.filter-multiple a.filter-selected').parents(".tab-pane:first").find(".table"));

    new_url(tab.find('.filter-multiple a.filter-selected'), selected_values)
    new_url(tab.find('.filter-multiple a.exclude-selected'), selected_values)

    if (tab.find('.table-info table tbody .total-selected').length > 0) {
      var graphcontainer = $(this).parents('div.tab-pane.active:first').find('.table')
      var total_selected = 0;
      if (graphcontainer.parents('article[id^="tops_"]').length > 0 ||
          graphcontainer.parents('article.tops.print-total').length > 0 ||
          graphcontainer.parents('#cardinality').length > 0) {

        graphcontainer.find('tr.selected td.last').each(function() {
          total_selected += parseFloat($(this).attr('value'));
        });

        tab.find('.table-info table tbody .total-selected span').html(total_selected);
        tab.find('.table-info table td.total-selected span').attr('value', total_selected);

        var $span = tab.find('.table-info table td.total-selected span');
        aggregation = $span.data('label') || $span.data('unit');

        cast_to(tab.find('.table-info table tbody .total-selected span'), aggregation);
      }

    } else if (tab.find('.table-info table tbody .total-row-selected').length > 0){
      tab.find('.table-info table td.total-row-selected span').html(tab.find('tr.selected').size());
    }
  }
});

// Elements area td that represent a unit
function cast_to(elements, unit) {
  elements.each(function(index, element) {
    quantity = parseInt($(element).attr('value'));
    if (quantity > 1e12) {
      quantity = (quantity / 1e12).toFixed(2);
      quantity = quantity + " T" + unit;
    } else if (quantity > 1e9) {
      quantity = (quantity / 1e9).toFixed(2);
      quantity = quantity + " G" + unit;
    } else if (quantity > 1e6) {
      quantity = (quantity / 1e6).toFixed(2);
      quantity = quantity + " M" + unit;
    } else if ( quantity > 1e3) {
      quantity = (quantity / 1e3).toFixed(2);
      quantity = quantity + " K" + unit;
    } else {
      quantity = quantity.toFixed(2);
      quantity = quantity + " " + unit;
    }

    $(element).html(quantity);
  });
}

function new_url(link, values) {
  var url = link.attr('data-link');

  var data = {
    values: values
  }

  url = url +"&" + $.param(data);
  link.attr('href', url);
}

function filter_selected(graphcontainer) {
  var selecteds = graphcontainer.find("tr.selected");
  var values    = new Array();

  for (var i=0; i<selecteds.length; i++) {
    var toogle = $(selecteds[i]).find(".serie a:first")

    // TODO: Check src and dst when flow module.
    //       It has to use vlan_ip and wan_ip.
    if ($(toogle).attr('data_filter') != undefined){
      serie_name = {};
      serie_name['src'] = $(toogle).attr('data_filter').split(" ")[0];
      serie_name['dst'] = $(toogle).attr('data_filter').split(" ")[1];
    } else if ($(toogle).attr('data_monitor') != undefined){
      serie_name = {};
      sensor_name = $(toogle).attr('data_monitor').split(" - ")[0];
      group_name = $(toogle).attr('data_monitor').split(" - ")[1];
      if (sensor_name != undefined) { serie_name['sensor_name'] = sensor_name; };
      if (group_name != undefined) { serie_name['group_name'] = group_name; };
    } else if ($(toogle).attr('data_serie') != undefined){
      serie_name = $(toogle).attr('data_serie');
    } else if ($(toogle).attr('data') != undefined){
      serie_name = $(toogle).attr('data');
    } else {
      serie_name = $(toogle).html();
    }
    values.push(serie_name);
  }

  return values;
}

$(document).on('change', 'body.widgets article .operator-select .add_chosen, body.alarms article .operator-select .add_chosen, body.dashboards .operator-select .add_chosen', function(event, data) {
  var value = $(this).val();
  var that = $(this).parents('.search-content-box');
  var column = that.find('div.column-select select').val();

  if (value === "empty" || value === "not_empty") {
    that.find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disabled>');
  } else if (column == "sensor_name" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="Enter search value" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "sensor_name" && value != "contains") {
    that.find('.value').html(sensors_html);
  } else if (column != "start_time" && column != "end_time" && column != "domain" && column != "group_id" && column != "sensor_name"){
    that.find('.value').html('<input class="search-content-value" placeholder="Enter search value" name="" type="text" x-webkit-speech lang="en-US">');
  };

  that.find('.add_chosen').chosen({
    allow_single_deselect: false,
    width: "100%"
  });
});

$(document).on('click', '.cardinality-group-selector li.dropdown-submenu ul a', function () {
  var parent = $(this).parents('.tab-pane');
  var tab = $('.tab-table', parent);

  if (tab.length === 0) {
    parent.append("<div class='tab-table'></div>");
    tab = $('.tab-table', parent);
  }

  $('.dropdown-toggle').dropdown('toggle');

  parent.find('.table-info table tbody .total-selected span').text(0);
  tab.html("<p class='lead text-center' style='clear: both'>" + I18n.t('loading') + "</p>");

  var group = $(this).data("group"),
    tab = $('li.tab-pane.active').attr("id"),
    graph = window["rb_" + tab],
    start_time = graph.maxDomain[0] / 1000,
    end_time = graph.maxDomain[1] / 1000,
    granularity = $('div.tab-pane.active .graph_main').data('granularity-sym'),
    section = $('.cardinality-group-selector').data('section'),
    url = "/" + section + "/" + tab + "/load_cardinality_table";

  $.ajax({
    url: url,
    type: 'GET',
    dataType: 'script',
    cache: false,
    data: {
      start_time: start_time,
      end_time: end_time,
      granularity: granularity,
      group_by: group
    }
  });

  $('.cardinality-group-selector').removeClass("open");
});

$(document).ready(function(){
  $('*[data-toggle=tooltip]').tooltip();
});

$(document).bind('ajaxComplete', function() {
  $('*[data-toggle=tooltip]').tooltip();
});

$(document).on('click', ".table-actions a.btn[data-toggle=tooltip]", function(event){
  event.preventDefault();
});

function test_settings_pathname(){
  return /^\/settings\/?$/.test(document.location.pathname)
}

$(document).on('click', 'a.block-ui-but, i.block-ui-but, li.block-ui-but, input.block-ui-but', function(e) {
  test_settings_pathname() ? void 0 : blockWebUI() ;
});

function hook_settings_please_wait(){
  if(test_settings_pathname()){
    $("#settings").find('form:first').submit(function() {
      blockWebUI();
    });
  }
}

$(document).ready(function(){
  hook_settings_please_wait()
});

$(document).on('click', 'tr.block-ui-but', function(e) {
  if( $(e.target).is('a') ){
    e.stopPropagation();
  } else {
    blockWebUI();
  }
});

var Flash = {

  templates: {

    render: function(source, data) {
      var self = this;

      var template = Handlebars.compile(source);
      return template(data);
    },

    flash: function(data){
      var self = this;

      var template = " \
      <div class='alert alert-{{type}}'> \
        <a class='close' data-dismiss='alert'>&#215;</a> \
        <div id='flash_{{type}}'> \
          <ul>{{message}}</ul> \
        </div> \
      </div>";
      return Flash.templates.render(template, data);
    }

  }

};

function show_alert(type, message){
  var html = Flash.templates.flash({type: type, message: message });
  $('#flash').html(html);
  $('#flash').show();
  $('#flash').animate({"top": "0"}, 500, function(e) {
    $(this).delay(2000).animate({"top": "-=80px"}, 500, function(e){
      $(this).hide();
    });
  });
}

function flash(data) {
  $('#flash').html("");

  $.each(flash_message, function(index, data) {
    var message = Flash.templates.flash(data);
    $('#flash').prepend(message);
    $('#flash').show();
    $('#flash').animate({"top": "0"}, 500, function(e){
      $(this).delay(2000).animate({"top": "-=80px"}, 500, function(e){
        $(this).hide();
      });
    });
    flash_message = [];
  });

  return false;
}

$(document).on('click', '#flash', function(event){

  $('#flash').animate({
    'top': "-=80px"
  }, 500, function(e){
    $(this).hide();
  });

});

$(document).on('mouseenter', '#flash', function(event){

  $('#flash').clearQueue();

});

$(document).on('mouseleave', '#flash', function(event){

  $('#flash').delay(1000).animate({
    'top': "-=80px"
  }, 500, function(e){
    $(this).hide();
  });

});

/*
 * Update general info table for RAW view.
 */
function update_raw_general_info(tab, aggregation){
  var total = parseFloat($(tab + ' .table-info table tbody .total').attr('value'));
  add_general_info(tab, total, 'td[data-label="' + aggregation + '"]');
}

/*
 * Update general info table for Top view.
 */
function update_tops_general_info(tab){
  var total = parseFloat($(tab + ' .table-info table tbody .total').attr('value'));
  add_general_info(tab, total, 'td.last');
}

/*
 * Read the info form the table and add results to General info table
 */
function add_general_info(tab, total, event_column) {
  var rows = $(tab +' table.table tbody tr').length;
  $(tab +' .table-info table tbody .rows').html(rows);

  var total_visible = 0;
  $(tab +' table.table ' + event_column).each(function() {
    total_visible += parseFloat($(this).attr('value'));
  });

  var percentage = 0;
  if ( total > 0 ) {
    percentage = total_visible/parseFloat(total)*100;
    if (percentage > 100) { percentage = 100 }
  }

  if (total < total_visible) {
    $(tab + ' .table-info table tbody .total').attr('value', total_visible);
  }

  $(tab +' .table-info table tbody .percentage span').html(percentage.toFixed(2));

  var columns = $(tab + ' .table-info table th');
  var table_size = $('.tabbable').width();
  var column_size = (table_size/columns.length);
  columns.each(function() {
    $(this).css('width', column_size);
  });
}

function table_sorter_update(tab) {
  if ($("#tab_" + tab + " table.table").data("updating")) {
      $("#tab_" + tab + " table.table").removeData("updating");
      return;
  }
  $("#tab_" + tab + " table.table").removeClass("table-striped");
  $("#tab_" + tab + " tr:odd").css("background-color", "#f9f9f9");
  $("#tab_" + tab + " tr:even").css("background-color", "#fff");
  $("#tab_" + tab + " tr").removeClass("odd even");
  $("#tab_" + tab + " tr:even").addClass("even");  
  $("#tab_" + tab + " tr:odd").addClass("odd");
  $("#tab_" + tab + " table.table").data("updating", true);
  $("#tab_" + tab + " table.table").trigger("update");
}

function update_bars_percent(tab) {
  var total = 0;
  $(tab +' td.last').each(function() {
    value = $(this).attr('value');
      total += parseFloat(value);
  });

  $(tab +' tbody tr').each(function() {
    value = $(this).find("td.last").attr('value');
    percentage = parseFloat(value)/total*100;
    $(this).find("div.bar").css('width', percentage.toString() + "%");
    $(this).find("div.bar span").text(percentage.toFixed(2).toString() + "%");
  });
}

$(document).on('click', '#report-create-button', function(e){
  if ($('body.cardinality div.tab-pane.active div.filter-multiple.filter-hide').length !== 0) {
    var group = $("div.tab-pane.active div.filter-multiple.filter-hide").attr("id");
    var newUrl = updateURLParameter($(this).attr("href"), "group_by", group);
    $(this).attr("href", newUrl);
  }

  if ($('#aggregation').length !== 0) {
    var aggregation = $('#aggregation > a').data("units");
    var newUrl = updateURLParameter($(this).attr("href"), "units", aggregation);
    $(this).attr("href", newUrl);
  }
});

/*
 *  Create a widget based on the parameters in the UI
 */
$(document).on('click', '#widget-create-button, #report-create-button', function (e) {
  e.preventDefault();

  var newUrl = $(this).attr('href');

  // Get actual parameters and add to the URL
  var widget_type = $(this).attr('data-widget-type');
  var granularity = $(this).attr('data-granularity');

  newUrl = updateURLParameter(newUrl, "granularity", granularity);
  if ($(this).attr('data-aggregation') !== 'null' && $(this).attr('data-aggregation').length > 0){
    newUrl = updateURLParameter(newUrl, "aggregation", $(this).attr('data-aggregation'));
  }
  var serie_type = $('#chart_types > a').text().replace(/^\s*|\s*$|(\s*((\r?\n){2,})\s*|\s*((\r?\n){1,2})\s*)/g,"$2$4").toLowerCase();

  // Check vars based on widget_type
  if(widget_type === 'top'){
    // TOP widgets
    var column = $('.nav.nav-tabs .tab-pane.active').attr('id');
    // Check if we are on map
    if (column.indexOf('_map') > -1){
      // Coordinates has a heatmap
      if (column === 'coordinates_map'){
        newUrl = updateURLParameter(newUrl, "graph_type", 'heatmap');
        newUrl = updateURLParameter(newUrl, "widget_type", 'heatmap');
      } else {
        newUrl = updateURLParameter(newUrl, "graph_type", 'map');
        newUrl = updateURLParameter(newUrl, "widget_type", 'map');
      }
    } else {
      // Multiserie
      if (granularity === 'all') {
        newUrl = updateURLParameter(newUrl, "graph_type", 'table');
      } else {
        newUrl = updateURLParameter(newUrl, "graph_type", 'multiserie');
      }
      newUrl = updateURLParameter(newUrl, "widget_type", widget_type);
      newUrl = updateURLParameter(newUrl, "serie_type", serie_type);
    }
    newUrl = updateURLParameter(newUrl, "elements", 5);
    newUrl = updateURLParameter(newUrl, "column", column);
    newUrl = updateURLParameter(newUrl, "range", $(this).attr('data-range'));
  } else if(widget_type === 'raw'){
    // RAW Widgets
    if(serie_type === 'streams'){
      newUrl = updateURLParameter(newUrl, "graph_type", 'stream');
      newUrl = updateURLParameter(newUrl, "elements", 50);
    } else {
      if (granularity === 'all') {
        newUrl = updateURLParameter(newUrl, "graph_type", 'table_raw');
      } else {
        newUrl = updateURLParameter(newUrl, "graph_type", 'serie');
      }
      newUrl = updateURLParameter(newUrl, "serie_type", serie_type);
      newUrl = updateURLParameter(newUrl, "elements", 5);
    }

    var columns = [];
    $('table.tablesorter thead tr th').each(function(index){
      if($(this).attr('data-column-name') !== undefined && $(this).attr('data-column-name').length > 0) {
        columns.push($(this).attr('data-column-name'));
      }
    });

    newUrl = updateURLParameter(newUrl, "stream_columns", columns);
    newUrl = updateURLParameter(newUrl, "range", $(this).attr('data-range'));
    newUrl = updateURLParameter(newUrl, "widget_type", widget_type);

  } else if (widget_type === 'unique'){
    // CARDINALITY widgets
    newUrl = updateURLParameter(newUrl, "serie_type", serie_type);

    var column = $('.nav.nav-tabs .tab-pane.active > a').attr('href').replace('#tab_', '');
    newUrl = updateURLParameter(newUrl, "column", column);

    // Check if we are on single or grouped unique
    if($('.tab-content .tab-pane.active table.tablesorter').length > 0){
      // Grouped
      var group_by = [];
      $('.tab-content .tab-pane.active table.tablesorter thead tr th').each(function(index){
        if($(this).attr('data-column-name') !== undefined && $(this).attr('data-column-name').length > 0) {
          group_by.push($(this).attr('data-column-name'));
        }
      });
      newUrl = updateURLParameter(newUrl, 'group_by', group_by);
      newUrl = updateURLParameter(newUrl, "widget_type", 'grouped_unique');
      if (granularity === 'all') {
        newUrl = updateURLParameter(newUrl, "graph_type", 'table');
      } else {
        newUrl = updateURLParameter(newUrl, "graph_type", 'multiserie');
      }
    } else {
      if (granularity === 'all') {
        newUrl = updateURLParameter(newUrl, "graph_type", 'table');
      } else {
        newUrl = updateURLParameter(newUrl, "graph_type", 'serie');
      }
      newUrl = updateURLParameter(newUrl, "widget_type", 'single_unique');
    }

    newUrl = updateURLParameter(newUrl, "range", $(this).attr('data-range'));

  } else if (widget_type === 'compare'){
    newUrl = updateURLParameter(newUrl, "widget_type", 'compare');
    if (granularity === 'all') {
      newUrl = updateURLParameter(newUrl, "graph_type", 'table');
    } else {
      newUrl = updateURLParameter(newUrl, "graph_type", 'multiserie');
    }
    newUrl = updateURLParameter(newUrl, "serie_type", serie_type);
    newUrl = updateURLParameter(newUrl, "range", $('.nav.nav-tabs .tab-pane.active > a').attr('href').replace('#tab_', ''));
  } else if (widget_type === 'monitor'){
    newUrl = updateURLParameter(newUrl, "range", $(this).attr('data-range'));
    newUrl = updateURLParameter(newUrl, "serie_type", serie_type);
    newUrl = updateURLParameter(newUrl, "widget_type", 'monitor');
    if (granularity === 'all') {
      newUrl = updateURLParameter(newUrl, "graph_type", 'table');
    } else {
      newUrl = updateURLParameter(newUrl, "graph_type", 'multiserie');
    }
    var category = $('.nav.nav-tabs .tab-pane.active > a').attr('href').replace('#tab_', '');
    newUrl = updateURLParameter(newUrl, "category", category);
  }

  // Create the form widget
  $('#default_modal').modal({
    backdrop: 'static',
    remote: newUrl
  });

});

// UnblockIU once the request has been full made.
$(document).on("page:receive", function(){
  $.unblockUI();
});

// show jQDSlider when clicking in time machine time selector
$(document).on('click', '.ranges.menus a.time_machine_', function(e){
  var parent_div = $("#tm_slider").parent();

  $(parent_div).toggleClass('hideDateRange');

  if($(parent_div).hasClass('hideDateRange')){
    $('.time_machine_ i').removeClass('fa-caret-up');
    $('.time_machine_ i').addClass('fa-caret-down');
  } else {
    $('.time_machine_ i').removeClass('fa-caret-down');
    $('.time_machine_ i').addClass('fa-caret-up');
  }
  e.preventDefault();
});

// show jQDateRangeSlider when clicking in custom time selector
$(document).on('click', '.ranges.menus a.custom', function(e){
  var parent_div = $("#slider").parent();

  $(parent_div).toggleClass('hideDateRange');

  if($(parent_div).hasClass('hideDateRange')){
    $('.custom i').removeClass('fa-caret-up');
    $('.custom i').addClass('fa-caret-down');
  } else {
    $('.custom i').removeClass('fa-caret-down');
    $('.custom i').addClass('fa-caret-up');
  }

  e.preventDefault();
});

/*
 * Listen on click to submit custom range.
 */
$(document).on('click', 'a.submitDateRange', function(e){
  var min = $("#slider").dateRangeSlider("min");
  var max = $("#slider").dateRangeSlider("max");
  var product = $(this).data('product');

  // get the offset of each value
  min_offset = min.getTimezoneOffset();
  max_offset = max.getTimezoneOffset();

  map = {};
  map['start_time'] = min.getTime()/1000;
  map['end_time']   = (max.getTime() + (24*3600000) - 1000)/1000;
  map['values'] = []

  $.ajax({
    url: '/filters/' + product + '/domain',
    remote: false,
    type: 'PATCH',
    data: map,
    success: function(data) {
      window.location = window.location.pathname;
    }
  });

  return false;
});

/*
 * Listen on click on filter Zoom to send the data
 */
$(document).on('click', '.custom_domain', function(e) {
  e.preventDefault();

  // Get the current product and check it
  var product = redBorder.product;
  if(product === ''){
    return false;
  }

  if ($(this).attr('data') == null){
    var tab = "rb"
  } else {
    var tab = 'rb_' + $(this).attr('data');
  }

  map = {};
  map['start_time'] = parseInt(window[tab].currentDomain()[0]/1000);
  map['end_time']   = parseInt(window[tab].currentDomain()[1]/1000);

  $.ajax({
    url: '/filters/' + product + '/domain',
    remote: false,
    type: 'PATCH',
    data: map,
    success: function(data) {
      window.location = window.location.pathname;
    }
  });
  return false;
});

function zoomGraph(tab) {
  var graph = 'rb';
  if (tab !== 'raw') {
    graph = 'rb_' + tab;
  }
  var end_time   = parseInt(window[graph].currentDomain()[1]);
  if (end_time < $.now()) {
    $('.custom_domain').css("display", "");
    $('.graph_outliers').hide();
    if (tab != 'raw') {
      $('.custom_domain').attr("data", tab);
    }
  }
  window[graph].elements.filter(function (d) {
    $(window[graph].semitop.selectAll('circle[class^="rb-point-' + d.name + '"]')[0]).hide();
  });
}

function zoomResetGraph(tab) {
  var graph = 'rb';
  if (tab !== 'raw') {
    graph = 'rb_' + tab;
  }
  $('.custom_domain').css("display", "none");
  $('.graph_outliers').show();
  window[graph].elements.filter(function (d) {
    if (d.visible === true) {
      $(window[graph].semitop.selectAll('circle[class^="rb-point-' + d.name + '"]')[0]).show();
    }
  });
}

function getUrlVars() {
    var vars = {};
    var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
        vars[key] = value;
    });
    return vars;
}

// Change the time in the input to unixtime
$(document).on('submit', '#time_machine_picker', function(e){
  date = new Date($('#time_selector_alt').val());
  $('#time_selector_alt').val(date.getTime()/1000);

  return true;
});

$(document).on('submit', '#time_machine_slider_picker', function(e){

  var time_selected = new Date($("#tm_slider").dateRangeSlider("max").getTime());
  var time_now = new Date(1000* getUrlVars().time_machine_now);

  time_selected.setHours(time_now.getHours() || 0);
  time_selected.setMinutes(time_now.getMinutes() || 0);
  time_selected.setSeconds(time_now.getSeconds() || 0);

  $('#time_selector_slider_alt').val(time_selected.getTime()/1000);

  return true
});

/*
* Copy to the clipboard. ONLY FOR IE
*
* @param value -> The text to set in the clipboard
*/
/*function copy_to_clipboard(value){
  var text_val=value;
  //text_val.focus();
  //text_val.select();
  if (!document.all) return; // IE only
  r = text_val.createTextRange();
  r.execCommand('copy');

  alert("Copied to the clipboard");
}*/

// ------------------------------------------------------
// JSON
// ------------------------------------------------------

function JSONSyntaxHighlight(json) {
  if (typeof json != 'string') {
    json = JSON.stringify(json, undefined, 2);
  }
  json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
  return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
      var cls = 'number';
      if (/^"/.test(match)) {
          if (/:$/.test(match)) {
              cls = 'key';
          } else {
              cls = 'string';
          }
      } else if (/true|false/.test(match)) {
          cls = 'boolean';
      } else if (/null/.test(match)) {
          cls = 'null';
      }
      return '<span class="' + cls + '">' + match + '</span>';
  });
}

// Global bar of position. This is needed to store the first position
// of the table info and hold it when the position is fixed.
var pos;

$(window).scroll(function() {
  var windowpos = $(window).scrollTop();
  var documentWidth = $(document).width();
  var containerWidth = $("#main").width();
  var reportWidth = $("#report-pages").width();
  // s for general info, reports for reports
  var s, reports;
  var actionsHeight;
  var table;
  var single = false;

  // ======================================================
  // Reports
  if($("#report-box-wrap").length > 0){

    reports = $("#report-box-wrap");
    isFixed = (reports.css('position') === 'fixed');

    if(!isFixed){
      pos = reports.offset();
    }

    // Check the height of the box.
    var report_box_h = $('#report-box-wrap').height();
    var report_blocks_h = $('#report-blocks-wrap').height();

    if((report_box_h < report_blocks_h) && ((windowpos + 15) >= pos.top && documentWidth > 767)) {
      reports.addClass("report-stick");
      reports.css("width", reportWidth + 'px');
      reports.css("left", "48.55%");
      reports.css("top", "17px");
      //s.css("left", (documentWidth - containerWidth)/2 + "px")
    } else {
      reports.removeClass("report-stick");
      reports.removeAttr("style");
    }

  }

  // End reports
  // ======================================================

  // General info tables
  if($(".tab-pane").length == 0){
    single = true;
    s = $(".table-info");
    actionsHeight = $(".table-info-actions").height();
    table = $("#events .table");
  } else {
    s = $(".tab-pane.active .table-info");
    actionsHeight = $(".tab-pane.active .table-info-actions").height();
    table = $(".tab-table");
  }

  if(s.hasClass('no-stick')){
    return;
  }

  if(s.length > 0){

    var isFixed = (s.css('position') === 'fixed');

    if(!isFixed){
      pos = s.offset();
    }

    if ((windowpos + 15) >= pos.top && documentWidth > 767) {
      // -12 is for the padding
      if(!isFixed){
        if(single){
          table.css("margin-top", (s.height() + actionsHeight + 20) + "px")
        } else {
          table.css("margin-top", (s.height() + actionsHeight - 20) + "px")
        }
      }
        s.addClass("table-stick");
        s.addClass("container");
        s.css("left", (documentWidth - containerWidth)/2 + "px")
    } else {
        s.removeClass("table-stick");
        s.removeClass("container");
        s.removeAttr("style")
        table.removeAttr("style")
    }
  }

  // Location Movements
  if ($("#location.movements").length > 0) {
    fixChordTop(windowpos);
  }

});

function reallocate_widget_4_print() {
  var margin_value = 9;
  var doc_height = 210 - (2*margin_value);

  var tam_pixels = $($(".widget_general")[0]).width();
  var tam_col = $($(".widget_general")[0]).data("ss-colspan");

  var tam_mm = tam_col * 35;

  var ratio = tam_pixels / tam_mm;


  var max_top_height = 0;
  for (var ind = 1; (ind == 1) || (max_top_height > ind * doc_height); ind++) {
    $(".widget_general").each(function(){
      var top_pixels = parseInt($(this).css("top"));
      var top_mm = top_pixels / ratio;

      var height_pixels = parseInt($(this).height());
      var height_mm = height_pixels / ratio;

      if (top_mm + height_mm > max_top_height) {
        max_top_height = top_mm + height_mm;
      }

      if(top_mm < (ind * doc_height) && (top_mm + height_mm > (ind * doc_height))){
        var diff = ((ind * doc_height) - top_mm);
        $(".widget_general").each(function(){
          var top_pixels_2 = parseInt($(this).css("top"));
          if (top_pixels_2 >= top_pixels){
            $(this).css("top", top_pixels_2 + (diff * ratio));
          }
        });
      }
    });
  }
};

// A funciton to calculate a legible contrast text color
function get_legible_color(hexcolor){

  hexcolor = hexcolor.replace("#","").toLowerCase();

  if(hexcolor.length == 3){ hexcolor = hexcolor + hexcolor; }

  colors = hexcolor.split(/([abcdef0-9]{2})/).filter(function(a){return a !== '';});

  sum = parseInt(colors[0],16) + parseInt(colors[1],16) + parseInt(colors[2],16)

  diff = sum - 382;

  if(diff < 0) {
    // Dark background
    return "#eeeeee";

  } else {
    // Light background
    diff = Math.abs(diff)

    return "#333333";

  }

}

// Alphabetical navigation used on users
$(document).on('click', 'nav.alphabetical a', function(event){

  $('nav.alphabetical a.active').removeClass('active');
  $(event.target).addClass('active');

});

function selectRowsOnRawTable (links, same_as_selected) {
  var columns = {};

  function remarkElements(links, selector) {
    for (var x in links) {
      var mySelector = selector.substr(0);
      var name = links[x].target.id;
      if (name === "N/A") name = "";

      if (name !== "others") {
        mySelector += ":has(td[data-label='" + links[x].target.column + "'][value='" + name + "'])";
      } else {
        for (var elementName in columns[links[x].target.column]) {
          mySelector += ":not(:has(td[data-label='" + links[x].target.column + "'][value='" + columns[links[x].target.column][elementName] + "']))";
        }
      }

      if (links[x].target && links[x].target.sourceLinks.length === 0) {
        $(mySelector).addClass("raw-selected-serie");
      } else {
        remarkElements(links[x].target.sourceLinks, mySelector);
      }
    }
  }

  function getColumnsAndValues(links) {
    for (var x in links) {
      var current = links[x],
        sourceName = current.source.id,
        targetName = current.target.id;

      if (sourceName !== "others") {
        if (sourceName === "N/A") sourceName = "";
        if (columns[current.source.column] === undefined) columns[current.source.column] = [];
        if (columns[current.source.column].indexOf(sourceName) === -1) {
          columns[current.source.column].push(sourceName);
        }
      }

      if (targetName !== "others") {
        if (targetName === "N/A") targetName = "";
        if (columns[current.target.column] === undefined) columns[current.target.column] = [];
        if (columns[current.target.column].indexOf(targetName) === -1) {
          columns[current.target.column].push(targetName);
        }
      }

      if (links[x].target && links[x].target.sourceLinks.length !== 0) {
        getColumnsAndValues(links[x].target.sourceLinks);
      }
    }
  }

  $('.raw-selected-serie').removeClass('raw-selected-serie');

  if (!same_as_selected) {
    var selector = "tr.raw-row",
      name = links[0].source.id;

    if (name === "N/A") name = "";

    if (name !== "others") {
      selector += ":has(td[data-label='" + links[0].source.column + "'][value='" + name + "'])";
    }

    getColumnsAndValues(rb.links);
    remarkElements(links, selector);
  }
}

function update_visible_total () {
  var tab = 'div.tab-pane.active'
  var td = 'td.last'

  var total = $(tab + ' .table-info table tbody .total').attr('value');
  add_general_info(tab, total, td)

  var columns = $(tab + ' .table-info table th');
  var table_size = $('.tabbable').width();
  var column_size = (table_size/columns.length);

  columns.each(function() {
    $(this).css('width', column_size);
  });
}

/*
 * Higlight the input when active a chosen container
 */
$(document).on('click', '.chosen-container-multi.form-control', function(event){
  $(this).addClass('focus');
  $(this).find('.chosen-drop').css('width', $(this).parent().width() + 'px');

  $(this).focusout(function(){
    $('.chosen-container-multi.form-control').removeClass('focus');
  })
});

/*
 * Avoid redirect on disabled links in breadcrumbs
*/
$(document).on('click', '.breadcrumb a.disabled', function(event){
  event.preventDefault();
});

/*
 * Disable the hide of panels when click on panel buttons
 */
$(document).on('click', '.panel-title.panel-group-toggle .pull-right.panel-button', function (e) {
  e.stopPropagation();
});

// Delete the highlight class on notifications
$(document).on('click', 'a.notifications', function (e){
  $(this).removeClass('bell-shake-delay');
});

/* ======================================================================
 *  MODALS
 * ====================================================================== */

/*
 * Delete the content of the modal to force the reload
 */
$(document).on('hidden.bs.modal', function (e) {
    if($(e.target).hasClass('keep')){
      return true;
    }

    $(e.target).removeData('bs.modal');
    $(e.target).find('.modal-content').html("");
});

// Hide show modals
function hide_modals(){
  $('.modal.fade.in').modal('toggle');
}

// Listen to reload the modal
// TODO: We must modularize this function
$(document).on("click", ".widget-selector a[data-target='#select_widget_type'], .reload-modal",function(ev) {
  // Prevent the link
  ev.preventDefault();

  if(!$(this).hasClass('disabled')){
    var target = $(this).attr("href");
    var modal = $(this).parents('.modal-dialog');

    modal.find('.modal-body').animate({
      opacity: 0
    }, 200, function(){

      // load the url and show modal on success
      modal.find('.modal-content').load(target, function() {
        //$("#select_widget_type").modal("show");
        modal.find('.modal-body').animate({
          opacity: 1
        }, 200);
      });

    });
  }
});

function table_stripped_format() {
  $('tr:not(.time_header):odd').css("background-color", "#f9f9f9");
  $('tr:not(.time_header):even').css("background-color", "#ffffff");
}

/*
 * Hide a category if the row event hasn't got any
 * detailed information about it.
 */
function hide_categories() {
  $('.well.clearfix').each(function() {
    if($(this).children('.col-md-3').length == 0) {
      $(this).hide();
    }
  });
}

// TODO move to a common modules js file
$(document).on('click', '.raw-element-btn', function(e) {
  var parent = $(this).parents('tr');
  var url = parent.attr('data-link');

  map = {};
  parent.find('td').each(function(){
    map[$(this).attr('data-label')] = $(this).attr('value');
  });

  $.ajax({
    url: url,
    remote: true,
    type: 'GET',
    data: { "custom_filter": map }
  });

  return false;
});

function add_tab_with_ajax(element) {
  blockWebUI();
  var href = $(element).attr("href");
  $.ajax({
            url: href,
            remote: true,
            type: 'GET',
            async: false,
            success: function(data) {
                 $.unblockUI();
            }
          });
}

$(document).on('click', '#tops li a', function(event) {
  event.preventDefault();
  add_tab_with_ajax(this);
});
