redBorder.widgets.graphs.vertical_bar = function (container, widget) {
  var graph,
      wtype,
      $container = $('#' + container);

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render(){
    wtype.queryList().then(draw);
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(data) {
    if (widget.property.product_type == "location") {
      for (var i = 0; i < data.length; i++) {
        var currentName = data[i].name;
        data[i].name = redBorder.widgets.locations && redBorder.widgets.locations[currentName] ? redBorder.widgets.locations[currentName] : currentName;
      }
    }

    graph = new RB.VerticalBars({
      container: container,
      data: data,
      color: widget.property.color,
      units: redBorder.widgets.unitsHandler(widget),
    });
  
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }  

  function reload() {
    $.when(wtype.queryList()).then(function(data){
      graph.setData(data);
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    }, function () {
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    });
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('width', $container.parents('.widget').width() + 'px');
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    graph.resize();
  }

  // Hide the main element when resizing
  function hide() {
    $container.find('svg').fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.find('svg').fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}