/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

function initChosen(list) {
  $('.chosen-select').chosen();
  $('div.chosen-container-multi').addClass('form-control');
  $('div.chosen-container-multi, label.chosen-container').show();
  if (list != undefined && list != null) {
    $('.chosen-select').setSelectionOrder(list, true);
  }
}

function initStreamChosen(product) {
  var order = $('.widget_stream_columns_'+ product + ' .chosen-select').getSelectionOrder();
  $('#widget_stream_columns_ordered').val(order);
}

function updateChosenValues(product) {
  $(".chosen-select").chosen({enable_search_threshold: 10}).change(function(e, option) {
    // Update the values of the selected/deselected items from the dropdown list (true or false)
    if (option !== undefined) {
      var val = option.selected !== undefined ? option.selected : option.deselected;

      $('.chosen-select option[value=' + val + ']').each(function () {
        $(this).attr('selected', option.selected !== undefined ? true : false);
      });
    }

    // Get the order of the selected items from the dropdown list
    var order = $('.widget_stream_columns_'+ product + ' .chosen-select').getSelectionOrder();
    // Remove an item from the list if it has been deselected
    if (option !== undefined && option.deselected !== undefined) {
      var i = order.indexOf(option.deselected);
      order.splice(i, 1);
    }

    // Set the order of the selected items to this hidden field before submit them
    $('#widget_stream_columns_ordered').val(order);
  });
}

function sendWidget() {
  if (window.rule !== undefined) {
    var rules = rule.pack().items,
        positions = [];

    // Find time filters if exists
    $.each(rules, function (index, value) {
      if (value['column'] == 'start_time' || value['column'] == 'end_time')
        positions.push(index);
    })

    // Remove Custom range if time filters are empty or uncompleted
    if ($('#widget_range').val() == 'custom' && positions < 2){
      $('#widget_range').val('last_24');
      $("#widget_range option[value='last_24']").attr('selected', 'selected');
    }

    // Disable time filters if the custom range is not selected
    if ($('#widget_range').val() != 'custom' && $('#widget_widget_type').val() != 'compare') {
      $.each(positions, function (index, value) {
        rules[value]['enabled'] = false
      })
    }

    $('#widget_filters, #report_block_filters').val(JSON.stringify(rules));
  }
  if ($('.combination-fields').length > 0) {
    var data = {}
    $('[data-serie-position].combination-fields').each(function () {
      var serie = $(this).data('serie-position');
      var wmodule = $('[data-serie-position="' + serie +'"] #widget_module').val();
      var aggregation = $('[data-serie-position="' + serie +'"] #widget_aggregation').val();
      var weight = $('[data-serie-position="' + serie +'"] #widget_weight').val();
      var offset = $('[data-serie-position="' + serie +'"] #widget_offset').val();
      var clientProfile = $('#widget_client_profile').val();
      var reference = $('[data-serie-position="' + serie +'"] #widget_reference').val();
      data[serie] = {
        mod: wmodule,
        weight: weight,
        offset: offset,
        reference: reference,
        filters: rule.pack('[data-serie-position="' + serie +'"] .search-content-box').items
      }
      if(wmodule === 'monitor'){
        data[serie]['category'] = aggregation
        data[serie]['agg'] = 'monitors'
      } else {
        data[serie]['agg'] = aggregation
        data['client_profile'] = clientProfile;
      }
    })
    $('<input />').attr('type', 'hidden')
                  .attr('name', 'widget[series]')
                  .attr('value', JSON.stringify(data))
                  .appendTo('.modal-content form');
  }
}

/* ======================================================================
 *  NEW WIDGET FORM
 * ====================================================================== */

/*
 * Update the link for graph
 */
function update_graph(graph){
  edit_link_graph_selector(6, graph);
}

/*
 * Update the link for type
 */
function update_type(type){
  edit_link_graph_selector(5, type);
}

function edit_link_graph_selector(index, value){
  var link = $('a.graph-next-step').attr('href').split('/');
  link[index] = value;
  $('a.graph-next-step').attr('href', link.join('/'))
}

// Listen for clicks on h3 elements. If the element clicked is not the
// Custom element, then submit the associated form in order to create the
// default widget
$(document).on("click", ".widget-selector h3", function (event) {
  if($(this).data('ignore') === undefined){
    $(this).siblings('form').submit();
    event.preventDefault();
  }
});

// Listen the click when change the graph example
$(document).on("click", ".widget-graph-selector", function(event){

  var graph_type = $(this).attr("data-widget-graph");

  if(graph_type !== undefined){
    // Disable the showed example
    $(".widget-graph-selector.selected").removeClass("selected");
    $(this).addClass("selected");

    $(".widget-graph-example > div").removeAttr("style");
    $("div[data-widget-graph-example='"+graph_type+"']").css("display", "block");

    // Update the graph
    update_graph(graph_type);
  }

});

// Listen the click on products
$(document).on("click", ".widget-product-selector .w-top-item", function(event){

  var active = $('.w-top-item.active');
  var product_type = $(this).attr('data-product-type');

  if(active.length > 0 && active.attr('data-product-type') != product_type){

    active.removeClass('active');
    $(this).addClass('active');

    $('.row[data-product-type="'+active.attr('data-product-type')+'"]').fadeOut(200, function(){
      $('.row[data-product-type="'+product_type+'"]').fadeIn(200);
    })
  } else if (active.length == 0) {
    $(this).addClass('active');
    $('.row[data-product-type="'+product_type+'"]').fadeIn(200);
  }


});

/*
* Since the combination "button" is a link, when the mouse goes over it, 
* it should change color like the rest of the buttons in "+Add block" reports.
*/
$(document).on('mouseover', '#wrapper', function(e){
  var h3 = document.getElementById("combination");
  h3.style.color = '#f26e57';
});
//This is reverting back to grey the combination button text
$(document).on('mouseout', '#wrapper', function(e){
  var h3 = document.getElementById("combination");
  h3.style.color = '#515151';
});

/* ======================================================================
 *  NEW WIDGETS
 * ====================================================================== */

/*
 * Disable gridster dragging on maps
 */
$(document).on('mouseover', '.widget .widget-body', function(e){
  if (redBorder.widgets.gridster !== undefined) {
    if (rbDashboardLocked !== true) {
      redBorder.widgets.gridster.disable();
    }
  } else if($('#report-pages').length > 0){
    // We are on reports
    var grid_idx = $(this).parents('.page-content').attr('data-gridster');
    redBorder.reports.pages[grid_idx].disable();
  } else {
    $('.widget .widget-body').off();
  }
});

$(document).on('mouseout', '.widget .widget-body', function(e){
  if (redBorder.widgets.gridster !== undefined) {
    if (rbDashboardLocked !== true) {
      redBorder.widgets.gridster.enable();
    }
  } else if($('#report-pages').length > 0){
    // We are on reports
    var grid_idx = $(this).parents('.page-content').attr('data-gridster');
    redBorder.reports.pages[grid_idx].enable();
  } else {
    $('.widget .widget-body').off();
  }
});

/*
 * Listen the click on a widget
 */
$(document).on('click', '.widget-body, .widget[data-widget-graph-type="text"] h4', function(event){

  var parent = $(this).parents('.widget');

  if(parent.attr('data-widget-click') !== undefined && parent.attr('data-widget-click') !== 'none'){
    blockWebUI();
    window.location.href = parent.attr('data-widget-url');
  }

});

/*
 * Do a reload when the user click on reload widget
 */
$(document).on('click', '.widget .widget-reload', function(e){
  // Remove fail class if exists
  $(this).parents('.widget').removeClass('fail');
  // Add widget reload class
  $(this).parents('.widget').addClass('reloading');

  // Update TimeNow
  redBorder.timeNow = redBorder.timeMachine || new Date();

  var id = $(this).parents('.widget').data('widget-id');
  redBorder.widgets.active["widget_" + id].reload();

  e.preventDefault();
});

/*
 * Allow a wisdget to drag and resize on absolute position dashboard.
 */
function initializeAbsoluteWidget(id) {
  $('.widget[data-widget-id="' + id + '"]').draggable({
    handle: ".widget-header",
    containment: [0,0],
    stop: function () {
      if (parseInt($(this).css("top")) < 0) {
        $(this).css("top", "0px");
      }

      $.ajax({
        url: "/dashboard/" + $('#dashboard').data('dashboard-id') + "/widgets/" + $(this).attr("data-widget-id") + "/set_absolute_position",
        type: 'POST',
        dataType: 'script',
        data: {
          x: $(this).css("left"),
          y: $(this).css("top")
        }
      });
    }
  });

  $('.widget[data-widget-id="' + id + '"]').resizable({
    resize: function () {
      //var w = redBorder.widgets.active['widget_' + id];
      redBorder.widgets.active["widget_" + id ].resize();
    },
    stop: function () {
      $.ajax({
        url: "/dashboard/" + $('#dashboard').data('dashboard-id') + "/widgets/" + $(this).attr("data-widget-id") + "/set_absolute_position",
        type: 'POST',
        dataType: 'script',
        data: {
          width: $(this).css("width"),
          height: $(this).css("height")
        }
      });
    }
  });
}
