#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module AlarmsHelper
  def int_to_hours num
    ret = num.to_i / 60
    if ret > 59
      (ret / 60).to_s + " hours"
    else
      ret.to_s + " minutes"
    end
  end

  def get_number_from_severity

    unless @alarm.severity.nil?

        case @alarm.severity.name
          when 'very low'
            # Very low
            return 0
          when 'low'
            # Low
            return 1
          when 'medium'
            # Medium
            return 2
          when 'high'
            # High
            return 3
          when 'very high'
            # Very High
            return 4
          when 'critical'
            # Critical
            return 5
          else
            # Very low by default
            return 0
          end
    end

    # By default, very low
    return 0

  end
end
