#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class MacObject < RedborderObject
  cacheable isolate: :user_id, key: :value, value: :name, expiration: 1.day,
            namespace: 'rb-webui'

  # Personal objects must have an user_id
  validates :user_id, presence: true

  private

  def update_cache
    vendor = Redborder::RbMacVendor.lookup value
    if name_changed?
      Rails.cache.write cache_route, name
      Rails.cache.write "rb-webui:macvendor:#{value}", vendor
    elsif value_changed?
      Rails.cache.delete cache_route_older
      Rails.cache.delete "rb-webui:macvendor:#{value_was}"
      Rails.cache.write cache_route, name
      Rails.cache.write "rb-webui:macvendor:#{value}", vendor
    end
  end

  def create_cache
    Rails.cache.write cache_route, name
    vendor = Redborder::RbMacVendor.lookup value
    Rails.cache.write "rb-webui:macvendor:#{value}", vendor
  end

  def delete_cache
    Rails.cache.delete cache_route
    vendor = Redborder::RbMacVendor.lookup value
    Rails.cache.delete "rb-webui:macvendor:#{value}"
  end
end
