#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rake db:seed (or created alongside the db with db:setup).
#
# Examples:
#
#   cities = City.create([{ name: 'Chicago' }, { name: 'Copenhagen' }])
#   Mayor.create(name: 'Emanuel', city: cities.first)

#Load Default Sensor (Root)
#unless ENV["RAILS_ENV"] && ENV["RAILS_ENV"] == "test"

if ENV["STUB_SENSORS"] != "1"
  sensor_root = Sensor.create_with(uuid: rand(1..9_223_372_036_854_775_807))
                  .find_or_create_by(name: 'root', type: 1, domain_type: 0)
  user_sensor_id = Sensor.root.id
else
  sensor_root = Sensor.new(id: 1)
  user_sensor_id = 1
end

# Default admin user setup
if User.all.blank?
  User.create(
    name: 'Administrator',
    login: RedBorder::USER_CONFIG['login'],
    email: RedBorder::USER_CONFIG['email'],
    password: RedBorder::USER_CONFIG['password'],
    password_confirmation: RedBorder::USER_CONFIG['password'],
    authentication_token: RedBorder::USER_CONFIG['authtoken'],
    admin: true,
    sensor_id: user_sensor_id,
    pwd_changed_at: Time.now
  )
end

# Default settings
Setting.find_or_create_by(name: 'company', value: 'redBorder Networks')
Setting.find_or_create_by(name: 'email', value: RedBorder::USER_CONFIG['email'])
Setting.find_or_create_by(name: 'rsa', value: nil)
Setting.find_or_create_by(name: 'minimum_password_length', value: '12')
Setting.find_or_create_by(name: 'session_timeout_time', value: '1800')
Setting.find_or_create_by(name: 'autoreload_time', value: '300')
Setting.find_or_create_by(name: 'autoreload_raw_time', value: '300')
Setting.find_or_create_by(name: 'geoip_country', value: 'https://dl.miyuru.lk/geoip/maxmind/country/maxmind4.dat.gz')
Setting.find_or_create_by(name: 'geoip_country_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_country_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_country_custom_file', value: nil)
Setting.find_or_create_by(name: 'geoip_country_md5', value: nil)
Setting.find_or_create_by(name: 'geoip_countryv6', value: 'https://dl.miyuru.lk/geoip/maxmind/country/maxmind6.dat.gz')
Setting.find_or_create_by(name: 'geoip_countryv6_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_countryv6_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_countryv6_custom_file', value: nil)
Setting.find_or_create_by(name: 'geoip_countryv6_md5', value: nil)
Setting.find_or_create_by(name: 'geoip_city', value: 'https://dl.miyuru.lk/geoip/maxmind/city/maxmind4.dat.gz')
Setting.find_or_create_by(name: 'geoip_city_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_city_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_city_custom_file', value: nil)
Setting.find_or_create_by(name: 'geoip_city_md5', value: nil)
Setting.find_or_create_by(name: 'geoip_cityv6', value: 'https://dl.miyuru.lk/geoip/maxmind/city/maxmind6.dat.gz')
Setting.find_or_create_by(name: 'geoip_cityv6_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_cityv6_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_cityv6_custom_file', value: nil)
Setting.find_or_create_by(name: 'geoip_cityv6_md5', value: 'nil')
Setting.find_or_create_by(name: 'geoip_asn', value: 'https://dl.miyuru.lk/geoip/maxmind/asn/maxmind4.dat.gz')
Setting.find_or_create_by(name: 'geoip_asn_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_asn_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_asn_custom_date', value: nil)
Setting.find_or_create_by(name: 'geoip_asn_md5', value: nil)
Setting.find_or_create_by(name: 'geoip_asnv6', value: 'https://dl.miyuru.lk/geoip/maxmind/asn/maxmind6.dat.gz')
Setting.find_or_create_by(name: 'geoip_asnv6_date', value: 'N/A')
Setting.find_or_create_by(name: 'geoip_asnv6_custom', value: '0')
Setting.find_or_create_by(name: 'geoip_asnv6_custom_file', value: nil)
Setting.find_or_create_by(name: 'geoip_asnv6_md5', value: nil)
Setting.find_or_create_by(name: 'login_banner', value: nil)
Setting.find_or_create_by(name: 'cli_banner', value: nil)
Setting.find_or_create_by(name: 'nmap_url', value: 'https://nmap.org/dist/nmap-7.92-1.x86_64.rpm')
Setting.find_or_create_by(name: 'sso_enabled', value: '0')
Setting.find_or_create_by(name: 'sso_lock_new_users', value: '0')
Setting.find_or_create_by(name: 'sp_entity_id', value: "https://#{`hostname -I`.strip.split(' ').first}/users/saml/metadata")
Setting.find_or_create_by(name: 'sp_sso_target', value: "https://#{`hostname -I`.strip.split(' ').first}/users/saml/auth")
Setting.find_or_create_by(name: 'idp_sso_target_url', value: 'http://example.com/saml/sso')
Setting.find_or_create_by(name: 'idp_slo_target_url', value: 'http://example.com/saml/slo')
Setting.find_or_create_by(name: 'idp_certificate', value: nil)
Setting.find_or_create_by(name: 'idp_entity_id', value: 'https://saml.example.com/entityid')
Setting.find_or_create_by(name: 'sp_sso_cert', value: nil)
Setting.find_or_create_by(name: 'sp_sso_priv_key', value: nil)
Setting.find_or_create_by(name: 'ai_selected_model', value: nil)
Setting.find_or_create_by(name: 'ai_allowed_cpus', value: nil)

DittoCode::Exec.if 'ENTERPRISE' do
  Setting.find_or_create_by(name: 'http_key', value: nil)
  Setting.find_or_create_by(name: 'http_key_file', value: nil)
  Setting.find_or_create_by(name: 'http_pem', value: nil)
  Setting.find_or_create_by(name: 'http_pem_file', value: nil)
end
Setting.find_or_create_by(name: 'proxy', value: '0')
Setting.find_or_create_by(name: 'proxy_address', value: nil)
Setting.find_or_create_by(name: 'proxy_port', value: nil)
Setting.find_or_create_by(name: 'proxy_user', value: nil)
Setting.find_or_create_by(name: 'proxy_password', value: nil)
Setting.find_or_create_by(name: 'autoresolv', value: '1')
Setting.find_or_create_by(name: 'forecast', value: '0')
Setting.find_or_create_by(name: 'server_key', value: 'NI83Ag1MyoBWiWnaYXWl0wSX84MCdF')
Setting.find_or_create_by(name: 'gmaps_key', value: nil)
Setting.find_or_create_by(name: 'gmaps_type', value: 'api_key')
Setting.find_or_create_by(name: 'webpage_url', value: '')
Setting.find_or_create_by(name: 'vulnerability_update_periodicity', value: 'weekly')
Setting.find_or_create_by(name: 'vulnerability_update_time', value: '00:00')
Setting.find_or_create_by(name: 'assets_update_periodicity', value: 'daily')
Setting.find_or_create_by(name: 'assets_update_time', value: '00:00')
Setting.find_or_create_by(name: 'time_series_model', value: 'DoubleExponentialSmoothingModel')
Setting.find_or_create_by(name: 'anomaly_model', value: 'DBScanModel')
Setting.find_or_create_by(name: 'ksgima_threshold', value: '3')
Setting.find_or_create_by(name: 'outliers_min_cycles', value: 1)
Setting.find_or_create_by(name: 'outliers_max_cycles', value: 15)
Setting.find_or_create_by(name: 'outliers_min_intervals', value: 100)
Setting.find_or_create_by(name: 'outliers_max_intervals', value: 1500)

# Default dashboards
user = User.find_by(login: 'admin', admin: true) or User.first

# Load Default Severities
Severity.find_or_create_by(sig_id: 14, name: 'critical', text_color: "#ffffff", bg_color: "#ff4643")
Severity.find_or_create_by(sig_id: 15, name: 'extremely high', text_color: "#ffffff", bg_color: "#ff4643")
Severity.find_or_create_by(sig_id: 13, name: 'very high', text_color: "#ffffff", bg_color: "#d24643")
Severity.find_or_create_by(sig_id: 1, name: 'high', text_color: "#ffffff", bg_color: "#aa4643")
Severity.find_or_create_by(sig_id: 2, name: 'medium', text_color: "#ffffff", bg_color: "#d9c03e")
Severity.find_or_create_by(sig_id: 3, name: 'low', text_color: "#ffffff", bg_color: "#89a54e")
Severity.find_or_create_by(sig_id: 4, name: 'very low', text_color: "#ffffff", bg_color: "#30BF93")
Severity.find_or_create_by(sig_id: 11, name: 'unknown', text_color: "#ffffff", bg_color: "#919191")
Severity.find_or_create_by(sig_id: 12, name: 'clean', text_color: "#ffffff", bg_color: "#5eca5e")

# Load Default Priorities
Priority.find_or_create_by(name: 'critical', text_color: "#ffffff", bg_color: "#ff4643")
Priority.find_or_create_by(name: 'high', text_color: "#ffffff", bg_color: "#aa4643")
Priority.find_or_create_by(name: 'medium', text_color: "#ffffff", bg_color: "#c69958")
Priority.find_or_create_by(name: 'low', text_color: "#ffffff", bg_color: "#89a54e")
Priority.find_or_create_by(name: 'none', text_color: "#ffffff", bg_color: "#30BF93")
Priority.find_or_create_by(name: 'unknown', text_color: "#ffffff", bg_color: "#919191")
Priority.find_or_create_by(name: 'info', text_color: "#ffffff", bg_color: "#5eca5e")

# IncidentStatus
IncidentStatus.find_or_create_by(name: 'Closed')
IncidentStatus.find_or_create_by(name: 'Containment Achieved')
IncidentStatus.find_or_create_by(name: 'Incident Reported')
IncidentStatus.find_or_create_by(name: 'New')
IncidentStatus.find_or_create_by(name: 'Open')
IncidentStatus.find_or_create_by(name: 'Rejected')
IncidentStatus.find_or_create_by(name: 'Restoration Achieved')
IncidentStatus.find_or_create_by(name: 'Stalled')

# Incidents deletion rules
Setting.find_or_create_by(name: "delete_incidents_duration", value: "90")
Setting.find_or_create_by(name: "delete_incidents_unit", value: "days")
Setting.find_or_create_by(name: "delete_incidents_status", value: "Closed")
Setting.find_or_create_by(name: "autoclose_incidents_unit", value: "days")
Setting.find_or_create_by(name: "autoclose_incidents_duration", value: "90")
Setting.find_or_create_by(name: "incidents_autoclose_enabled", value: "1")
Setting.find_or_create_by(name: "incidents_deletion_enabled", value: "1")

# Incidents priority filter
Setting.find_or_create_by(name: 'incidents_priority_filter', value: 'high')

# Auto delete stored jobs rules
Setting.find_or_create_by(name: "autodelete_stored_jobs_duration", value: "90")

existing_default = PlaybookTemplate.find_by(default: true)

# Redborder default playbook
default_playbook = PlaybookTemplate.find_or_create_by(name: 'Redborder Incident Playbook') do |playbook|
  playbook.description = 'This playbook, created and maintained by Redborder, offers a comprehensive default response plan for incidents. Organizations can use it as a template to develop their own playbooks, allowing for a tailored incident response process.'
  playbook.user = user
  playbook.read_only = true

  playbook.default = true unless existing_default
end

# Default phases of default playbook
default_identification_phase = PhaseTemplate.find_or_create_by(name: 'Identification', playbook_template: default_playbook)
default_containment_phase = PhaseTemplate.find_or_create_by(name: 'Containment', playbook_template: default_playbook)
default_eradication_phase = PhaseTemplate.find_or_create_by(name: 'Eradication', playbook_template: default_playbook)
default_recovery_phase = PhaseTemplate.find_or_create_by(name: 'Recovery', playbook_template: default_playbook)

# Identification phase tasks
default_identification_task01 = TaskTemplate.find_or_create_by(name: 'Review Incident',
                                                               summary: 'Record evidence to determine the incident status as Rejected, Open or Incident Reported.',
                                                               description: 'Document detailed evidence and findings to accurately finalize the incident status. This will guide further actions and ensure proper tracking of the incidents lifecycle.',
                                                               phase_template: default_identification_phase)
default_identification_task02 = TaskTemplate.find_or_create_by(name: 'Analyze Indicators',
                                                               summary: 'Confirm any malicious or suspicious reputations and document the findings.',
                                                               description: 'Perform a thorough analysis of indicators to identify any malicious or suspicious activities. Record the analysis results to inform the next steps in the response process.',
                                                               phase_template: default_identification_phase)
default_identification_task03 = TaskTemplate.find_or_create_by(name: 'Identify Affected Hosts',
                                                               summary: 'Summarize findings from investigations of hosts with malicious indicators.',
                                                               description: ' Investigate and compile a report on all hosts showing malicious indicators. Include details of the indicators and the extent of the compromise to aid in containment efforts.',
                                                               phase_template: default_identification_phase)
default_identification_task04 = TaskTemplate.find_or_create_by(name: 'Confirm Incident',
                                                               summary: 'Update incident status to "Incident Reported" and initiate triage and collaboration if assignees are involved.',
                                                               description: 'Officially change the incident status to "Incident Reported" and start the triage process. If there are assignees, initiate collaboration among them to coordinate the response efforts.',
                                                               phase_template: default_identification_phase)
default_identification_task05 = TaskTemplate.find_or_create_by(name: 'Document and Notify',
                                                               summary: 'Create an incident ticket with all relevant parameters and contextual information.',
                                                               description: 'Generate a comprehensive incident ticket that includes all necessary details and context. Notify relevant parties to ensure everyone is informed and can take appropriate actions.',
                                                               phase_template: default_identification_phase)

# Containment phase tasks
default_containment_task01 = TaskTemplate.find_or_create_by(name: 'Isolate Systems',
                                                            summary: 'Isolate affected systems to prevent further spread of the threat.',
                                                            description: 'Disconnect compromised systems from the network to contain the threat and prevent it from spreading to other systems. Ensure isolation procedures are documented.',
                                                            phase_template: default_containment_phase)
default_containment_task02 = TaskTemplate.find_or_create_by(name: 'Apply Temporary Fixes',
                                                            summary: 'Implement temporary fixes to mitigate the impact of the incident.',
                                                            description: 'Apply interim solutions to address the immediate effects of the incident. These fixes are temporary measures until a permanent resolution can be implemented.',
                                                            phase_template: default_containment_phase)
default_containment_task03 = TaskTemplate.find_or_create_by(name: 'Notify Stakeholders',
                                                            summary: 'Inform all relevant stakeholders about the containment measures taken.',
                                                            description: 'Communicate with all relevant parties, including management and technical teams, about the containment actions. Provide updates on the status and next steps.',
                                                            phase_template: default_containment_phase)

# Eradication phase tasks
default_eradication_task01 = TaskTemplate.find_or_create_by(name: 'Remove Malware',
                                                            summary: 'Remove all instances of malware from affected systems.',
                                                            description: 'Execute thorough malware removal procedures on all compromised systems. Ensure all malware components are identified and eradicated.',
                                                            phase_template: default_eradication_phase)
default_eradication_task02 = TaskTemplate.find_or_create_by(name: 'Clean Systems',
                                                            summary: 'Ensure affected systems are free of any malicious software.',
                                                            description: 'Perform a deep clean of affected systems to verify the absence of any malicious software. Use advanced tools and techniques to ensure complete system hygiene.',
                                                            phase_template: default_eradication_phase)
default_eradication_task03 = TaskTemplate.find_or_create_by(name: 'Verify Eradication',
                                                            summary: 'Confirm that all traces of the threat have been completely eradicated.',
                                                            description: 'Conduct a comprehensive verification process to ensure that the threat has been entirely removed from all systems. Validate this through multiple checks and confirmations.',
                                                            phase_template: default_eradication_phase)

# Recovery phase tasks
default_recovery_task01 = TaskTemplate.find_or_create_by(name: 'Restore Systems',
                                                         summary: 'Restore systems to their normal operational state.',
                                                         description: 'Rebuild and restore systems to their pre-incident state. Ensure that all functionalities are reinstated and that the systems are fully operational.',
                                                         phase_template: default_recovery_phase)
default_recovery_task02 = TaskTemplate.find_or_create_by(name: 'Verify Functionality',
                                                         summary: 'Check that all systems are functioning correctly post-restoration.',
                                                         description: 'Test all restored systems to confirm they are working as expected. Validate that no functionalities are compromised and that the systems are stable.',
                                                         phase_template: default_recovery_phase)
default_recovery_task03 = TaskTemplate.find_or_create_by(name: 'Monitor Systems',
                                                         summary: 'Continuously monitor systems to ensure the threat does not reappear.',
                                                         description: 'Implement ongoing monitoring of the systems to detect any signs of the threat re-emerging. Use advanced monitoring tools and techniques to ensure continuous oversight.',
                                                         phase_template: default_recovery_phase)
default_recovery_task04 = TaskTemplate.find_or_create_by(name: 'Review Incident',
                                                         summary: 'Conduct a thorough review of the incident and the response actions taken.',
                                                         description: 'Analyze the incident in detail, assessing the response actions and their effectiveness. Identify any lessons learned and areas for improvement.',
                                                         phase_template: default_recovery_phase)
default_recovery_task05 = TaskTemplate.find_or_create_by(name: 'Update Documentation',
                                                         summary: 'Update all relevant documentation to reflect the details and responses to the incident.',
                                                         description: 'Revise and enhance all documentation to include the full incident history, response actions taken, and any follow-up measures. Ensure that this information is accessible for future reference and training.',
                                                         phase_template: default_recovery_phase)

#Load Default Lookups
Lookup.find_or_create_by(title: "whois.sc", value: "http://www.whois.sc/${ip}")
Lookup.find_or_create_by(title: "Shodan", value: "https://www.shodan.io/search?query=${ip}")

# Asign sensor_root to all users with Top Domain nil
User.where(sensor_id: nil).update_all(sensor_id: sensor_root.id)
#end

DittoCode::Exec.if 'ENTERPRISE' do
  # Tiers
  Tier.find_or_create_by(name: Tier::DEFAULT_TIER_NAME, user_id: user.id)
  Tier.find_or_create_by(name: 'hot', user_id: user.id, memory: true)
end

# Network Objects
NetObject.find_or_create_by(name: 'localhost', value: '127.0.0.1', comment: '', user_id: User.first.id)

# Protocol Objects
load(Rails.root.join('db', 'seeds', 'protocol_objects.rb'))

# Service Objects
load(Rails.root.join('db', 'seeds', 'service_objects.rb'))

# Application Objects
load(Rails.root.join('db', 'seeds', 'application_objects.rb'))

# Redborder AI Models
ModelSource.where(name: "Llava").first_or_create(description: "Llava model", url: "https://repo.redborder.com/mirror-models/llava-v1.5-7b-q4.llamafile", md5url: "https://repo.redborder.com/mirror-models/llava-v1.5-7b-q4.llamafile.md5", enable: false)

ModelSource.where(name: "TinyLlama").first_or_create(description: "TinyLlama model", url: "https://repo.redborder.com/mirror-models/TinyLlama-1.1B-Chat-v1.0.F16.llamafile", md5url: "https://repo.redborder.com/mirror-models/TinyLlama-1.1B-Chat-v1.0.F16.llamafile.md5", enable: false)

ModelSource.where(name: "Mistral-7b").first_or_create(description: "Mistral 7b", url: "https://repo.redborder.com/mirror-models/mistral-7b-instruct-v0.2.Q4_0.llamafile", md5url: "https://repo.redborder.com/mirror-models/mistral-7b-instruct-v0.2.Q4_0.llamafile.md5", enable: false)