/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

if (redBorder.malware === undefined){
  redBorder.malware = {}
}

// Emails view library
redBorder.malware.Emails = function() {
  // Initilize callbacks
  initialize();

  // Initialize the library
  function initialize() {
    callbacks();
  }

  /*
   * Add Callbacks to the elements
   */
  function callbacks() {
    $(document).on('click', '.email-free, .email-remove', function(e){
      var $button = $(this);
      // Show a loader
      $button.html('<i class="fa fa-spinner fa-spin"></i>');
      $button.parents('.email').addClass('disabled');
    });
  }

  /*
   * Destroy callbacks
   */
  function destroyCallbacks() {
    $(document).off('click', '.email-free, .email-remove');
  }

  /*
   * Remove an email from given email
   */
  function removeEmail(id) {
    $('.email[data-id="' + id + '"]').fadeOut(150, function(){
      $(this).remove();
    });
  }

  /*
   * Remove an email from given email
   */
  function enableEmail(id) {
    $('.email[data-id="' + id + '"]').removeClass('disabled');
  }

  // Return the object
  return {
    destroyCallbacks: destroyCallbacks,
    removeEmail: removeEmail,
    enableEmail: enableEmail
  }
}
