/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

redBorder.widgets.types.by_sensor = function (widget) {
  // This method return the first and last view of the element and the current
  // score.
  //
  // This query return a deferred object
  function queryTotal() {
    return $.ajax({
      url: "/malware/by_sensor",
      type: 'GET',
      dataType: 'json',
      data: {
        w: true,
        range: widget.property.range,
        sensor_type: widget.property.sensor_type
      }
    }).then(function (data) {
      return data.total;
    });
  }

  function queryTendency() {
    var range = widget.wtype.end_time_secs - widget.wtype.start_time_secs;

    return $.ajax({
      url: "/malware/by_sensor",
      type: 'GET',
      dataType: 'json',
      data: {
        w: true,
        start_time: widget.wtype.start_time_secs - range,
        end_time: widget.wtype.end_time_secs - range,
        sensor_type: widget.property.sensor_type
      }
    }).then(function (data) {
      return data.total;
    });
  }

  return {
    queryTotal: queryTotal,
    queryTendency: queryTendency
  }
}
