/*!    
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Load events and show in the table
 */
function loadEvents(data, index) {
  if (data.name === undefined) { return; }

  var value = $("article#propagation").data('value'),
      node_type = $(".propagation-selector .btn.btn-success").data('nodetype');

  $('.propagation-events').replaceWith(
    '<div class="propagation-events loading">' + 
      '<i class="fa fa-spinner fa-pulse"></i> Loading events for ' + data.name +
    '</div>');

  // Load data
  $.ajax({
    url: "/malware/" + value + "/propagation_events/" + node_type,
    type: 'GET',
    dataType: 'html',
    data: {
      node: data.name,
      range: activeRange()
    }
  }).done(function(html){
    $('.propagation-events').replaceWith(html);
    $('.propagation-events-panel .panel-title').html('Events of ' + data.name);
  });
}
