/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

/* ========================================================================
 *  CUSTOM MENU
 * ======================================================================== */

$(document).on('contextmenu', 'ul.nav.nav-tabs.monitor li', function(event) {
  event.preventDefault();
  $("ul.custom-menu").remove();
  custom_menu_html = "<ul class='custom-menu'><li class='custom-menu-option' data-action='close_tab'>Close</li><li class='custom-menu-option' data-action='close_others'>Close others tabs</li><li class='custom-menu-option' data-action='close_right'>Close tabs to the right</li></ul>"
  $(this).append(custom_menu_html);
  var custom_menu = $(this).find('ul.custom-menu');
  if(custom_menu.length) { custom_menu.finish().toggle(100); }

  setTimeout(function() {
    custom_menu.hide(100);
 }, 3000);

});

function custom_menu_action_monitor(option) {
  var start_index = 0;
  var tabs = $("ul.nav.nav-tabs.monitor li span a.close");
  var action_tab_id = $(option).parent().parent()[0].id;
  var action_tab_index = 0;

  for (var i = 0; i < tabs.length; i++) {
    if (tabs[i].parentElement.parentElement.id == action_tab_id) {
      action_tab_index = i;
      break;
    }
  }

  // We are gonna delete from the actual action tab till the end
  // Not checking the previous ones.
  if ($(option).attr("data-action") == "close_right") {
    start_index = action_tab_index + 1;
  }

  if ($(option).attr("data-action") == "close_tab") {
    tabs[action_tab_index].click();
  } else {
    // Close the tabs from start_index till the end
    if (start_index >= 0 && action_tab_index >= 0 && start_index <= tabs.length) {
      for (var i = tabs.length - 1; i >= start_index; i--) {
        if (i != action_tab_index) {
           // tabs[i].click();
           var href = $("<div></div>").append(tabs[i]).find("a").first().attr("href");
           $.ajax({
            url: href,
            remote: true,
            type: 'PATCH',
            async: false
           });
        }
      }
    }
  }

  // Hide it AFTER the action was triggered
  $(".custom-menu").hide(100);
}
/* ======================================================================== */
$(document).on('click', 'ul.nav.nav-tabs.monitor li', function(e) {

  if (e.currentTarget.className == "custom-menu-option") {
    custom_menu_action_monitor($(this)); return;
  }

  var tab = $(this).attr('id');
  // When change the tab we must update the
  // tutorial steps: 2, 3
  var step8 = $("[data-step='8']");

  // Save the current guide
  var step8intro = step8.attr("data-intro");
  step8.removeAttr("data-step");
  step8.removeAttr("data-intro");

  $("#tab-table-" + tab).attr("data-step", "8");
  $("#tab-table-" + tab).attr("data-intro", step8intro);

  $.ajax({
    url: '/monitor/change_session_tab',
    remote: true,
    type: 'PATCH',
    data: { "tab": tab }
  });

  window['rb_' + tab].resize();

  return false;
});

var flash_message   = [];
var csrf = $('meta[name="csrf-token"]').attr('content');

$(document).on('click', 'div#new_saved_monitor_filter_modal button.new-saved-search-record', function(e) {
  e.preventDefault();

  var model = $(this).attr('data-model');

  var url = '/saved_monitor_filters/create';
  var title = $('input#saved_monitor_filter_title').val();
  var search_public = $('input#saved_monitor_filter_public').is(":checked");

  if ($('#saved-search-form #saved_monitor_filter_title').val()=="") {
    $('#saved-search-form #saved_monitor_filter_title').css('border' ,  "2px solid #FD2E3F");
  } else {
    var dd = false;

    if (typeof rule !== "undefined") {
      dd = rule.pack();
    } else {
      var json = $('div#search-params').text();

      if (json) {
        try {
          var tmp = JSON.parse(json)
          dd = {
            filter: tmp.search
          };
        } catch(e) {
          dd = false;
        }
      };
    };

    if (dd) {
      $('#saved-search-form .form-actions button.new-saved-search-record').attr('disabled', true);
      $('#saved-search-form .form-actions button.new-saved-search-record').text(I18n.t('javascript.please'));

      $.ajax({
        url: url,
        global: false,
        dataType: 'json',
        cache: false,
        type: 'POST',
        data: {
          "authenticity_token": csrf,
          "filter": {
            "title": title,
            "public": search_public,
            "filter": dd
          }
        },
        success: function(data) {
          flash_message.push({type: 'success', message: I18n.t('javascript.your_search')});
          flash();
          $('.modal').modal('hide');
        },
        error: function(data) {
          var errors = $.parseJSON(data.error().responseText).error;
          $.each(errors, function(index, error) {
            flash_message.push({type: 'error', message: error});
          });
          flash();
          $('.modal').modal('hide');
        }
     });

    } else {
      flash_message.push({type: 'error', message: I18n.t('javascript.unknown_error')});
      flash();
      $(document).trigger('limp.close');
      $('.modal').modal('hide');
    };
  }
  return false;
});

var SearchMonitor;
var sensors_monitor_html;
var domain_monitor_html;
SearchMonitor = function() {

  function SearchMonitor(selectData, callback) {
    var self = this;
    self.html = Handlebars.templates['search-rule']({});
    self.columns = selectData.monitor_columns;

    //Translating from init.rb
    for(var i = 0; i < self.columns.length; i++) {
      if (self.columns[i].value.startsWith("tr")) {
        self.columns[i].value = I18n.t(self.columns[i].value.slice(3))
      }
    }

    self.operators = selectData.operators;

    self.selectData = selectData;
    self.sensors = selectData.monitor_sensors;
    self.groups = selectData.groups;
    self.domains = selectData.domains;

    self.init();
    return self;
  };

  SearchMonitor.prototype = {

    init: function(callback) {
      var self = this;
      var width = "100%";

      self.columns_html = Handlebars.templates['select']({
        name: "column-select",
        placeholder: I18n.t('javascript.choose_query'),
        width: width,
        data: {
          value: self.columns
        }
      });

      self.sensors_html = Handlebars.templates['select']({
        name: "sensors-select",
        width: width,
        multiple: false,
        data: self.sensors
      });
      sensors_monitor_html = self.sensors_html;

      self.groups_html = Handlebars.templates['select']({
        name: "groups-select",
        width: width,
        multiple: false,
        data: self.groups
      });

      self.domains_html = Handlebars.templates['select']({
        name: "domains-select",
        width: width,
        multiple: false,
        data: self.domains
      });
      domain_monitor_html = self.domains_html;

      self.operators_html = function($html, data) {
        var select = Handlebars.templates['select']({
          name: "operators-select",
          width: width,
          data: {
            value: data
          }
        });

        $html.find('div.operator-select').html(select);
      };

      self.datetime_picker = function(that) {
        that.datetimepicker({
          timeFormat: 'HH:mm',
          dateFormat: 'yy-mm-dd',
          numberOfMonths: 1,
          separator: ' '
        });
      };

    },

    searchUI: function(data, callback) {
      var self = this;
      $('#content #title').after(Handlebars.templates['search'](data));

      $('.search-content-remove').on('click', function(e) {
        e.preventDefault();
        self.remove(this);
      });

      $('div.search-content-enable input').on('click', function() {
        if ($(this).is(':checked')) {
          $(this)
          .parents('.search-content-box')
          .find('.value *, .operator-select *, .column-select *')
          .attr('disabled', false).css('opacity', 1);
        } else {
          $(this)
          .parents('.search-content-box')
          .find('.value *, .operator-select *, .column-select *')
          .attr('disabled', true).css('opacity', 0.8);
        };

        $('.add_chosen').trigger("chosen:updated");
      });

      $('button.submit-search').on('click', function(e) {
        e.preventDefault();
        self.submit();
      });

      $('#content #title').on('click', 'a.reset-search-form', function(e) {
        e.preventDefault();

        $('.rules').empty();

        self.add();
        self.add();
        self.add();
      });

      if (callback && (typeof callback === "function")) {
        callback();
      };
    },

    add: function(that, newOptions, callback) {
      var self = this;
      var options = {};

      if (options && (typeof options === "object")) {
        options = newOptions;
      };

      var $html = $(self.html);
      $html.find('div.column-select').html(self.columns_html);
      self.operators_html($html, self.operators.text_input);

      if (that && (typeof that === "object")) {
        $(that).parents('.search-content-box').after($html);
      } else if (that && (typeof that === "string")) {
        $(that).append($html);
      } else {
        $('.rules').append($html);
      };

      $html.find('.add_chosen')
      .chosen({allow_single_deselect: false, width: "100%"})
      .change(function(event, data) {
        var value = $(this).val();
        var that = $(this).parents('.search-content-box');

        if (value === "user") {
          that.find('.value').html(self.users_html);
          self.operators_html($html, self.operators.text_input);
        } else if (value === "start_time") {
          that.find('.value').html('<input id="time-'+ new Date().getTime() +'" class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text">');
          self.datetime_picker(that.find('.value input:first'))
          self.operators_html($html, self.operators.datetime);
        } else if (value === "end_time") {
          that.find('.value').html('<input id="time-'+ new Date().getTime() +'" class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text">');
          self.datetime_picker(that.find('.value input:first'))
          self.operators_html($html, self.operators.datetime);
        } else if (value === "domain") {
          that.find('.value').html(self.domains_html);
          self.operators_html($html, self.operators.select);
        } else if (value === "group_id") {
          that.find('.value').html(self.groups_html);
          self.operators_html($html, self.operators.select_reduced);
        } else if (value === "sensor_name") {
          that.find('.value').html(self.sensors_html);
          self.operators_html($html, self.operators.select);
        } else {
          that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text">');
          self.operators_html($html, self.operators.text_input);
        };

        that.find('.add_chosen').chosen({
          allow_single_deselect: false, width: "100%"
        });

        if (callback && (typeof callback === "function")) {
          callback(that);
        };

        that.trigger('rbsearch:search:change');
      });

      $('.search-content-box:first')
      .find('.search-content-remove')
      .css('opacity', 1)
      .unbind('hover')
      .unbind('mouseover');

      return $html;
    },

    remove: function(that) {
      var self = this;
      if ($('.search-content-box').length > 2) {
        $(that).parents('.search-content-box').remove();
      } else if ($('.search-content-box').length == 2) {
        $(that).parents('.search-content-box').remove();

        $('.search-content-box:first')
        .find('.search-content-remove')
        .css('opacity', 0.4)
        .attr('title', I18n.t('javascript.you_must'));
      };
    },

    pack: function(that) {
      var self = this;
      var matchAll = false;

      if ($('#search select.global-match-setting').val() === "all") {
        matchAll = true;
      };

      var json = {
        match_all: matchAll,
        items: {}
      };

      var fields = '.search-content-box'
      if (that && (typeof that === "string")) {
        fields = that;
      }

      $(fields).each(function(index, item) {
        var enabled = $(item).find('.search-content-enable input').is(':checked');
        var column = $(item).find('.column-select select').val();
        var operator = $(item).find('.operator-select select').val();
        var value = $(item).find('.value input, .value select').val();

        if (enabled){
          if (column == "start_time" || column == "end_time"){
            if ($(item).find('.value input').datetimepicker("getDate") == null) {
              alert(I18n.t('javascript.valid_date'));
              throw I18n.t('javascript.valid_date')
            }
            else{
              value = $(item).find('.value input').datetimepicker("getDate").getTime() / 1000;
              //value = new Date(value).getTime() / 1000; it doesn't work in Safari
            }
          }

          if ((column !== "") || (value !== "")) {
            json.items[index] = {
              column: column,
              operator: operator,
              value: value,
              enabled: enabled
            };
          };
        }
      });

      return json;
    },

    submit: function(callback, otherOptions) {
      var self = this;
      var search = self.pack();
      var csrf = $('meta[name="csrf-token"]').attr('content');

      if (typeof otherOptions !== "object") {
        otherOptions = {};
      };

      var update_url = function() {
        if (history && history.pushState) {
          history.pushState(null, document.title, '/filters/monitor/advanced');
        };
      };

      if (callback && (typeof callback === "function")) {
        callback(search, self);
      };

      if (search && !$.isEmptyObject(search.items)) {
        if (otherOptions.search_id) {
          post_to_url('/filters/monitor/advanced', {
            match_all: search.match_all,
            search: search.items,
            title: otherOptions.title,
            search_id: ""+otherOptions.search_id+"",
            authenticity_token: csrf
          });
        } else {
          post_to_url('/filters/monitor/advanced', {
            match_all: search.match_all,
            search: search.items,
            authenticity_token: csrf
          });
        };
      } else {
        flash_message.push({type: 'error', message: I18n.t('javascript.you_cannot')});flash();
      };
    },

    build: function(search, where) {
      var self = this;

      if (typeof search === "string") {
        var data = JSON.parse(search);
      } else if (typeof search === "object") {
        var data = search;
      } else {
        var data = {};
      };

      if (data.items) {
       var rules = data.items;
      } else if (data.search) {
        var rules = data.search;
      } else {
        var rules = {};
      };

      if (data.match_all && data.match_all === "false") {
       $('select.global-match-setting option[value="any"]').prop('selected', 'selected');
      } else {
        $('select.global-match-setting option[value="all"]').prop('selected', 'selected');
      };

      for (id in rules) {
        var item = rules[id];

        var rule = (where !== undefined ? self.add(where) : self.add(false, {}));

        var column = rule.find('div.column-select select');

        rule.bind('rbsearch:search:change', function() {
          var operator = $(this).find('div.operator-select select');
          var value = $(this).find('div.value select, div.value input');

          operator.find("option[value='"+item.operator+"']").prop('selected', 'selected');
          operator.trigger("chosen:updated");

          if (item.column === "start_time" || item.column === "end_time") {
            if ($.isNumeric(item.value)) {
              date = new Date(item.value*1000);
            } else {
              date = new Date(Date.parse(item.value, "yyyy-MM-dd HH:mm"))
            }
            date_string = $.datepicker.formatDate( "yy-mm-dd", date);
            date_hours = date.getHours();
            date_minutes = date.getMinutes();

            if (date_hours < 10) { date_hours = "0" + date_hours; }
            if (date_minutes < 10) {date_minutes = "0" + date_minutes; }

            value.prop('value', date_string + " " + date_hours + ":" + date_minutes);
          } else {
            if (operator.val() == "empty" || operator.val() == "not_empty") {
              $(this).find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disabled>');
            }else {
              if ((item.column === "sensor_name" || item.column === "domain") && operator.val() == "contains") {
                $(this).find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disable x-webkit-speech lang="en-US">');
                var value = $(this).find('div.value select, div.value input');
              } else if (item.column === "sensor_name" || item.column === "domain") {
                var that = $(this).parents('.search-content-box');
                that.find('.value').html(self.sensors_html);
              }
              value.prop('value', item.value);
            }

          }

          rule.unbind('rbsearch:search:change');
        });

        rule.attr('data-rule-id', id);

        column.find("option[value='"+item.column+"']").prop('selected','selected');
        column.trigger("chosen:updated").trigger('change');

        if (item.enabled === "false") {
          rule.find('div.search-content-enable input').prop('checked', false);
          rule.find('.value *, .operator-select *, .column-select *')
          .attr('disabled', true).css('opacity', 0.8);
        };
      };

      $('.rules .add_chosen').trigger("chosen:updated");
    },

  };

  return SearchMonitor;
}();

$(document).on('change', 'body.monitor article .operator-select .add_chosen', function(event, data) {
  var value = $(this).val();
  var that = $(this).parents('.search-content-box');
  var column = that.find('div.column-select select').val();

  if (value === "empty" || value === "not_empty") {
    that.find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disabled>');
  } else if (column == "sensor_name" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "sensor_name" && value != "contains") {
    that.find('.value').html(sensors_monitor_html);
  } else if (column == "domain" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "domain" && value != "contains") {
    that.find('.value').html(domain_monitor_html);
  } else if (column != "start_time" && column != "end_time" && column != "domain" && column != "group_id" && column != "sensor_name"){
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  };

  that.find('.add_chosen').chosen({
    allow_single_deselect: false,
    width: "100%"
  });
});

function displayDiagram(container, cluster_mode, nprobes, nodes, s3_nodes, historical_nodes, broker_nodes, web_nodes, samza_nodes, middle_managers, rb_enrich, realtimes, http2k, postgresql, memcached) {
  var g = new dagreD3.Digraph();
  var modules = Object.keys(redBorder.modules);
  var kafka_nodes = "";
  var topics = ["rb_event", "rb_flow"]

  if (s3_nodes == undefined) {
    g.addNode("s3", { label: I18n.t('javascript.local_storage') });
  }else if (s3_nodes.length > 0) {
    g.addNode("s3", { label: I18n.t('javascript.s3_cloud') + s3_nodes.join(', ') });
  } else {
    g.addNode("s3", { label: I18n.t('javascript.s3_cloud') });
  }

  for (j in topics) {
    for (i in nodes[topics[j]]) {
      if (nodes[topics[j]].hasOwnProperty(i)) {
        kafka_nodes += nodes[topics[j]][i].leader + " (" +  nodes[topics[j]][i].partition + "), "
      }
    }
  }

  kafka_nodes = kafka_nodes.substr(0, kafka_nodes.length-2);

  if (cluster_mode == "samza"){
    g.addNode("samza", { label: "Samza: " + samza_nodes.join(', ') });
    g.addNode("middle_managers", { label: "MiddleManagers: " + middle_managers.join(', ') });
    g.addEdge(null, "samza", "middle_managers");
    g.addEdge(null, "middle_managers", "s3");
  } else if (cluster_mode == "rb-enrich") {
    g.addNode("rb-enrich", { label: "rb-enrich: " + rb_enrich.join(', ') });
    g.addNode("realtime", { label: "Realtimes: " + realtimes.join(', ') });
    g.addEdge(null, "rb-enrich", "realtime");
    g.addEdge(null, "realtime", "s3");
  } else if (cluster_mode == "realtime"){
    g.addNode("realtime", { label: "Realtimes: " + realtimes.join(', ') });
    g.addEdge(null, "realtime", "s3");
  } else {
    if (cluster_mode == undefined)
      cluster_mode = "unknown";
    g.addNode(cluster_mode, { label: "X" });
    g.addEdge(null, cluster_mode, "s3");
  }

  g.addNode("kafka", { label: "Kafka: " + kafka_nodes })
  g.addEdge(null, "kafka", cluster_mode)

  if(http2k.length > 0) {
    g.addNode('data_load_balancer', { label: 'Data Load Balancer' });
    g.addNode('http2k', { label: 'http2k: ' + http2k.join(', ') });
    g.addEdge(null, 'data_load_balancer', 'http2k');
    g.addEdge(null, 'http2k', 'kafka');
  }

  modules.forEach(function (m) {
    if (window["add_node_" + m] !== undefined) window["add_node_" + m](g, nprobes)
  });

  g.addNode("users", { label: "Front Load Balancer" })

  if(memcached.length > 0){
    g.addNode("memcached", { label: "Memcached: " + memcached.join(', ') });
  } else {
    g.addNode("memcached", { label: "Memcached" });
  }

  if(postgresql.length > 0){
    g.addNode("postgresql", { label: "Postgresql: " + postgresql.join(', ') });
  } else {
    g.addNode("postgresql", { label: "Postgresql" });
  }

  modules.forEach(function (m) {
    if (window["add_nodes_diagram_" + m] !== undefined) window["add_nodes_diagram_" + m](g, nprobes, nodes)
  });

  for (var i = 0; i < historical_nodes.length; i++) {
    g.addNode("historical" + i, { label: "Historical: " + historical_nodes[i] });
    g.addEdge(null, "s3", "historical" + i);
  }

  for (var i = 0; i < broker_nodes.length; i++) {
    g.addNode("broker" + i, { label: "Broker: " + broker_nodes[i] });
    g.addEdge(null, "broker" + i, "memcached");
    g.addEdge(null, "broker" + i, "postgresql");
    for (var j = 0; j < historical_nodes.length; j++) {
      g.addEdge(null, "historical" + j, "broker" + i);
    }
  }

  for (var i = 0; i < web_nodes.length; i++) {
    g.addNode("web" + i, { label: "Web: " + web_nodes[i] });
    g.addEdge(null, "web" + i, "users");
    g.addEdge(null, "web" + i, "memcached");
    g.addEdge(null, "web" + i, "postgresql");
    for (var j = 0; j < broker_nodes.length; j++) {
      g.addEdge(null, "broker" + j, "web" + i);
    }
  }

  var layout = dagreD3.layout().rankSep(40);
  var renderer = new dagreD3.Renderer();
  renderer.layout(layout).run(g, d3.select("#" + container + " svg g"));
}

$(document).on('click', '.table .selectable-segment', function(e) {
  if( $(e.target).is('a') ){
    e.stopPropagation();
  } else {
    var row = $(this);

    row.toggleClass('selected');

    if ( row.hasClass('selected') ) {
      row.find("td").css('background-color', '#FFC');
    } else {
      row.find("td").css('background-color', '');
    }

    if ($("tr.selected").length > 0) {
      $('#delete-selected').removeClass('delete-hide');
      $('#delete-selected').addClass('delete-show');
    } else {
      $('#delete-selected').removeClass('delete-show');
      $('#delete-selected').addClass('delete-hide');
    }
  }
});

$(document).on('click', '#delete-selected', function () {
  var todel = [];

  $('.selectable-segment.selected').each(function () {
    todel.push($(this).data('segment-id'));
  });

  $.ajax({
    url: '/monitor/delete_segments',
    type: 'POST',
    dataType: 'script',
    global: false,
    cache: false,
    data: {
      ids: todel
    }
  });
});
