/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('click', '.vault-btn', function(e) {
  var parent = $(this).parents('tr');
  var url = parent.attr('data-link');

  map = {};
  parent.find('td').each(function(){
    map[$(this).attr('data-label')] = $(this).attr('value');
  });

  $.ajax({
    url: url,
    remote: true,
    type: 'GET',
    data: { "custom_filter": map }
  });

  return false;
});

/* ========================================================================
 *  CUSTOM MENU
 * ======================================================================== */

$(document).on('contextmenu', 'ul.nav.nav-tabs.vault li', function(event) {
  event.preventDefault();
  $("ul.custom-menu").remove();
  custom_menu_html = "<ul class='custom-menu'><li class='custom-menu-option' data-action='close_tab'>Close</li><li class='custom-menu-option' data-action='close_others'>Close others tabs</li><li class='custom-menu-option' data-action='close_right'>Close tabs to the right</li></ul>"
  $(this).append(custom_menu_html);
  var custom_menu = $(this).find('ul.custom-menu');
  if(custom_menu.length) { custom_menu.finish().toggle(100); }

  setTimeout(function() {
    custom_menu.hide(100);
 }, 3000);

});

function custom_menu_action_vault(option) {
  var start_index = 0;
  var tabs = $("ul.nav.nav-tabs.vault li span a.close");
  var action_tab_id = $(option).parent().parent()[0].id;
  var action_tab_index = 0;

  for (var i = 0; i < tabs.length; i++) {
    if (tabs[i].parentElement.parentElement.id == action_tab_id) {
      action_tab_index = i;
      break;
    }
  }

  // We are gonna delete from the actual action tab till the end
  // Not checking the previous ones.
  if ($(option).attr("data-action") == "close_right") {
    start_index = action_tab_index + 1;
  }

  if ($(option).attr("data-action") == "close_tab") {
    tabs[action_tab_index].click();
  } else {
    // Close the tabs from start_index till the end
    if (start_index >= 0 && action_tab_index >= 0 && start_index <= tabs.length) {
      for (var i = tabs.length - 1; i >= start_index; i--) {
        if (i != action_tab_index) {
           // tabs[i].click();
           var href = $("<div></div>").append(tabs[i]).find("a").first().attr("href");
           $.ajax({
            url: href,
            remote: true,
            type: 'PATCH',
            async: false
           });
        }
      }
    }
  }

  // Hide it AFTER the action was triggered
  $(".custom-menu").hide(100);
}
/* ======================================================================== */

$(document).on('click', 'ul.nav.nav-tabs.vault li', function(e) {

  if (e.currentTarget.className == "custom-menu-option") {
    custom_menu_action_vault($(this)); return;
  }

  var tab = $(this).attr('id');
  var group = $(this).attr('data-group'); //compare or tops
  var _href = $('a[data-target="#export_csv_modal"]').attr("href");
  if(_href !== undefined)
    $('a[data-target="#export_csv_modal"]').attr('href', _href.replace(/&group=[^&]*/,''));

  if(group === "comparative_tab"){
    // When change the tab we must update the
    // tutorial steps: 8
    var step8 = $("[data-step='8']");
    // Save the current guide
    var step8intro = step8.attr("data-intro");
    step8.removeAttr("data-step");
    step8.removeAttr("data-intro");

    $("#tab-table-" + tab).attr("data-step", "8");
    $("#tab-table-" + tab).attr("data-intro", step8intro);

  } else {
    // When change the tab we must update the
    // tutorial steps: 10, 11
    var step10 = $("[data-step='10']");
    var step11 = $("[data-step='11']");

    // Save the current guide
    var step10intro = step10.attr("data-intro");
    step10.removeAttr("data-step");
    step10.removeAttr("data-intro");

    $("#table-info-" + tab).attr("data-step", "10");
    $("#table-info-" + tab).attr("data-intro", step10intro);

    var step11intro = step11.attr("data-intro");
    step11.removeAttr("data-step");
    step11.removeAttr("data-intro");

    if(group === "cardinality_tab"){
      $("#table-info-" + tab + " .cardinality-group-selector").attr("data-step", "11");
      $("#table-info-" + tab + " .cardinality-group-selector").attr("data-intro", step11intro);
    } else {
      $("#tab-table-" + tab).attr("data-step", "11");
      $("#tab-table-" + tab).attr("data-intro", step11intro);
    }
  }

  $.ajax({
    url: '/vault/change_session_tab',
    remote: true,
    type: 'PATCH',
    data: { "tab": tab, "group": group }
  });

  window['rb_' + tab].resize();

  return false;
});

$(document).on('click', 'body.vault .hide_total', function() {
  var tabs = $(this).find('a').attr('data-tabs').split(" ");
  var value = $(this).find('a').attr('data-value');
  var parent_id = $(this).parents('body').attr('class').split(" ");

  $.ajax({
    url: '/vault/change_session_total',
    remote: true,
    type: 'PATCH',
    data: { "value": !($.parseJSON(value)) },
    success: function() {
      var max = (parent_id[1] === "cardinality" ? 1 : 0);

      if ($.parseJSON(value)) {
        var text = I18n.t('javascript.hide_total');
        $.each(tabs, function(i,t){
          var graph = 'rb_' + t;
          if (window[graph].elements.length > max) {
            window[graph].unhide('Total');
          }
        });

      } else {
        var text = I18n.t('javascript.show_total');
        $.each(tabs, function(i,t){
          var graph = 'rb_' + t;
          if (window[graph].elements.length > max) {
            window[graph].hide('Total');
          }
        });
      }
      $('.hide_total a[data-value]').attr('data-value', !($.parseJSON(value)));
      $('.hide_total a[data-value]').html(text);
      $('div#total').removeClass('open');
    }
  });

  return false;
});

var flash_message   = [];
var csrf = $('meta[name="csrf-token"]').attr('content');

$(document).on('click', 'div#new_saved_vault_filter_modal button.new-saved-search-record', function(e) {
  e.preventDefault();

  var url = '/saved_vault_filters/create';
  var title = $('input#saved_vault_filter_title').val();
  var search_public = $('input#saved_vault_filter_public').is(":checked");

  if ($('#saved-search-form #saved_vault_filter_title').val()=="") {
    $('#saved-search-form #saved_vault_filter_title').css('border' , "2px solid #FD2E3F");
  } else {
    var dd = false;

    if (typeof rule !== "undefined") {
      dd = rule.pack();
    } else {
      var json = $('div#search-params').text();

      if (json) {
        try {
          var tmp = JSON.parse(json)
          dd = {
            filter: tmp.search
          };
        } catch(e) {
          dd = false;
        }
      };
    };

    if (dd) {
      $('#saved-search-form .form-actions button.new-saved-search-record').attr('disabled', true);
      $('#saved-search-form .form-actions button.new-saved-search-record').text(I18n.t('javascript.please'));

      $.ajax({
        url: url,
        global: false,
        dataType: 'json',
        cache: false,
        type: 'POST',
        data: {
          "authenticity_token": csrf,
          "filter": {
            "title": title,
            "public": search_public,
            "filter": dd
          }
        },
        success: function(data) {
          flash_message.push({type: 'success', message: I18n.t('javascript.your_search')});
          flash();
          $('.modal').modal('hide');
        },
        error: function(xhr) {
          var error = $.parseJSON(xhr.responseText).error;
          flash_message.push({type: 'error', message: error});
          flash();
          $(document).trigger('limp.close');
          $('.modal').modal('hide');
        }
     });

    } else {
      flash_message.push({type: 'error', message: I18n.t('javascript.unknown_error')});
      flash();
      $(document).trigger('limp.close');
      $('.modal').modal('hide');
    };
  }
  return false;
});

/* ========================================================================
 *  MAP VIEW
 * ======================================================================== */

/*
 *  Catch the click on trackc lients button and show the menu
 */
$(document).on('click', '.element.maps-tracking a', function(e){
  var $parent  = $(this).parent();
  var $options = $parent.find('.element-options');

  if($options.hasClass('open')){
    // Hide the menu
    $options.removeClass('open');
    $options.fadeOut(150);
  } else {
    // Show the menu
    var sensor_id = $parent.data('sensor-id');
    var range = $options.find('#track-range').val();
    var clients = $options.find('.track-clients');

    $options.addClass('open');
    $options.fadeIn(150);

    // We need to load the clients?
    if(clients.find('.clients ul.main li').length == 0){

      clients.addClass('loading');
      getClients(sensor_id, range, 0);

      // Bind the event to infinite scroll
      clients.find('.clients').bind('scroll', function(){
        if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight){
          getClients(sensor_id, range, $(this).find('ul.main li').length);
        }
      });
    }
  }

  event.preventDefault();

});

/*
 *  Track the search input. It's display the searched elements
 *  in a new list.
 */
$(document).on("keypress", '.search-clients', function (e) {
  var search = $(this).val();
  var parent = $(this).parents('.maps-tracking');
  var clients = $(this).parents('.element-options').find('.track-clients');
  var range = $('#track-range').val();
  var sensor_id = parent.data('sensor-id');

  if (e.which == 13 && search.length > 2) {

    // Remove latest search
    parent.find('ul.search li').remove();
    clients.find('.clients').unbind('scroll');
    clients.find('.clients').removeClass('no-data')
    clients.addClass('loading');
    parent.find('ul.main').fadeOut(100);

    searchClients(sensor_id, range, 0, search);

    // bind the event to infinite scroll
    clients.find('.clients').bind('scroll', function(){
      if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight){
        searchClients(sensor_id, range, $(this).find('ul.search li').length, search);
      }
    });

  } else if(e.which == 13 && search.length == 0){
    parent.find('ul.search li').remove();
    parent.find('ul.main').fadeIn(100);
    clients.find('.clients').unbind('scroll');

    clients.find('.clients').bind('scroll', function(){
      if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight){
        getClients(sensor_id, range, $(this).find('ul.main li').length);
      }
    })
  }

});

/*
 *  Change the list when the range selector changes.
 */
$(document).on('change', '#track-range', function(e){
  var me = $(this);

  // When change the range, we must reload the lists
  var clients = $(this).parents('.track-clients');
  var sensor_id = $(this).parents('.maps-tracking').data('sensor-id');
  var search = $('.search-clients').val();

  // Unbind event scroll
  clients.find('.clients').unbind('scroll');

  // Remove all elements
  clients.find('ul.main li, ul.search li').remove();
  clients.addClass('loading');
  clients.find('.clients').removeClass('no-data')

  // Load new elements
  if(search.length > 2){
    // Search is active
    // Bind the event to infinite scroll
    clients.find('.clients').bind('scroll', function(){
      if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight){
        if(clients.find('ul.search li').length > 0){
          getClients(sensor_id, me.val(), clients.find('ul.search li').length);
        }
      }
    });

    searchClients(sensor_id, $(this).val(), 0, search);
  } else {
    // Bind the event to infinite scroll
    clients.find('.clients').bind('scroll', function(){
      if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight){
        if(clients.find('ul.main li').length > 0){
          getClients(sensor_id, me.val(), clients.find('ul.main li').length);
        }
      }
    });

    getClients(sensor_id, $(this).val(), 0);
  }

});

function getClients(sensor_id, range, offset){
  $.get( "/vault/clients?sensor_id=" + sensor_id + "&offset=" + offset + "&range=" + range, function( data ) {
    $('.element.maps-tracking .track-clients').removeClass('loading');
    var $list = $('.element.maps-tracking .track-clients ul.main');

    if (data.clients.length == 0){
      $list.parent().unbind('scroll');

      if(offset == 0){
        $list.parents('.clients').addClass('no-data');
      }
    } else {
      for(var i = 0; i < data.clients.length; i++){
        $list.append('<li class="client" data-mac="'+data.clients[i].client_mac+'">'+data.clients[i].client_mac_name+'</li>');
      }
    }

  });
}

function searchClients(sensor_id, range, offset, search){
  $.get( "/vault/search_clients?sensor_id=" + sensor_id + "&offset=" + offset + "&search=" + search + "&range=" + range, function( data ) {
    $('.element.maps-tracking .track-clients').removeClass('loading');
    var $list = $('.element.maps-tracking .clients ul.search');

    if (data.clients.length == 0){
      $list.parent().unbind('scroll');

      if(offset == 0){
        $list.parents('.clients').addClass('no-data');
      }
    } else {
      for(var i = 0; i < data.clients.length; i++){
        $list.append('<li class="client" data-mac="'+data.clients[i].client_mac+'">'+data.clients[i].client_mac_name+'</li>');
      }
    }

  });
}

/*
 *  Get the data of the user to show in the map
 */
$(document).on('click', '.element-options .clients .client', function(e){
  var mac = $(this).data('mac');
  var self = this;

  if ($(this).hasClass('selected')){
    var mapa = redBorder.maps["vault"].getRbMap();
    $(this).removeClass('selected');
    $(self).css('border-color', '');

    // Remove the polyline
    mapa.removePolyline(mac);
    if(mapa.getPolylines().length === 0){
      mapa.setMarkersOpacity(1);
    }
  } else if(!$(this).hasClass('loading')) {
    var parent = $(this).parents('.maps-tracking');
    var range = parent.find('#track-range').val();
    var sensor_id = parent.data('sensor-id');
    $(this).addClass('loading');

    $.get( "/vault/client_points?sensor_id=" + sensor_id + "&mac_address=" + mac + "&range=" + range, function( data ) {

      $(self).removeClass('loading');

      if(data.positions.length > 0){
        var polyline;
        var markers = [];
        var mapa = redBorder.maps["vault"].getRbMap();

        for(var i = 0; i < data.positions.length; i++){
          // Get the last position of a user in a minute
          if(data.positions[i].result[data.positions[i].result.length - 1].client_latlong !== undefined && data.positions[i].result[data.positions[i].result.length - 1].client_latlong !== null){
            var latlong = data.positions[i].result[data.positions[i].result.length - 1].client_latlong.split(',');
            markers.push(new google.maps.LatLng(latlong[0], latlong[1]));
          }
        }

        var iconsetngs = {
          path: google.maps.SymbolPath.FORWARD_CLOSED_ARROW
        };

        var opts = {
          strokeOpacity: 0.8,
          strokeWeight: 3,
          icons: [{
              repeat: '70px',
              icon: iconsetngs,
              offset: '100%'}]
        };

        var strokeColor = mapa.addPolyline(markers, opts, data.client);
        mapa.setMarkersOpacity(0.2);
        $(self).css('border-color', strokeColor);
        $(self).addClass('selected');
      }

    });
  }
});

/* ========================================================================
 *  SEARCH VAULT
 * ======================================================================== */

var SearchVault;
var sensors_vault_html;
var zones_vault_html;
var domain_vault_html;

SearchVault = function() {

  function SearchVault(selectData, callback) {
    var self = this;
    self.html = Handlebars.templates['search-rule']({});
    self.columns = selectData.vault_columns;

    //Translating from init.rb
    for(var i = 0; i < self.columns.length; i++) {
      if (self.columns[i].value.startsWith("tr")) {
        self.columns[i].value = I18n.t(self.columns[i].value.slice(3))
      }
    }

    self.operators = selectData.operators;

    self.selectData = selectData;
    self.sensors = selectData.vault_sensors;
    self.zones = selectData.vault_zones;
    self.domains = selectData.domains;

    self.init();
    return self;
  };

  SearchVault.prototype = {

    init: function(callback) {
      var self = this;
      var width = "100%";

      self.columns_html = Handlebars.templates['select']({
        name: "column-select",
        placeholder: I18n.t('javascript.choose_query'),
        width: width,
        data: {
          value: self.columns
        }
      });

      self.sensors_html = Handlebars.templates['select']({
        name: "sensors-select",
        width: width,
        multiple: false,
        data: self.sensors
      });
      sensors_vault_html = self.sensors_html;

      self.zones_html = Handlebars.templates['select']({
        name: "zones-select",
        width: width,
        multiple: false,
        data: self.zones
      });
      zones_vault_html = self.zones_html;

      self.domains_html = Handlebars.templates['select']({
        name: "domains-select",
        width: width,
        multiple: false,
        data: self.domains
      });
      domain_vault_html = self.domains_html;

      self.operators_html = function($html, data) {
        var select = Handlebars.templates['select']({
          name: "operators-select",
          width: width,
          data: {
            value: data
          }
        });

        $html.find('div.operator-select').html(select);
      };

      self.datetime_picker = function(that) {
        that.datetimepicker({
          timeFormat: 'HH:mm',
          dateFormat: 'yy-mm-dd',
          numberOfMonths: 1,
          separator: ' '
        });
      };

    },

    searchUI: function(data, callback) {
      var self = this;
      $('#content #title').after(Handlebars.templates['search'](data));

      $('.search-content-remove').on('click', function(e) {
        e.preventDefault();
        self.remove(this);
      });

      $('div.search-content-enable input').on('click', function() {
        if ($(this).is(':checked')) {
          $(this)
          .parents('.search-content-box')
          .find('.value *, .operator-select *, .column-select *')
          .attr('disabled', false).css('opacity', 1);
        } else {
          $(this)
          .parents('.search-content-box')
          .find('.value *, .operator-select *, .column-select *')
          .attr('disabled', true).css('opacity', 0.8);
        };

        $('.add_chosen').trigger("chosen:updated");
      });

      $('button.submit-search').on('click', function(e) {
        e.preventDefault();
        self.submit();
      });

      $('#content #title').on('click', 'a.reset-search-form', function(e) {
        e.preventDefault();

        $('.rules').empty();

        self.add();
        self.add();
        self.add();
      });

      if (callback && (typeof callback === "function")) {
        callback();
      };
    },

    add: function(that, newOptions, callback) {
      var self = this;
      var options = {};

      if (options && (typeof options === "object")) {
        options = newOptions;
      };

      var $html = $(self.html);
      $html.find('div.column-select').html(self.columns_html);
      self.operators_html($html, self.operators.text_input);

      if (that && (typeof that === "object")) {
        $(that).parents('.search-content-box').after($html);
      } else if (that && (typeof that === "string")) {
        $(that).append($html);
      } else {
        $('.rules').append($html);
      };

      $html.find('.add_chosen')
      .chosen({allow_single_deselect: false, width: '100%'})
      .change(function(event, data) {
        var value = $(this).val();
        var that = $(this).parents('.search-content-box');

        if (value === "start_time") {
          that.find('.value').html('<input id="time-'+ new Date().getTime() +'" class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text">');
          self.datetime_picker(that.find('.value input:first'))
          self.operators_html($html, self.operators.datetime);
        } else if (value === "end_time") {
          that.find('.value').html('<input id="time-'+ new Date().getTime() +'" class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text">');
          self.datetime_picker(that.find('.value input:first'))
          self.operators_html($html, self.operators.datetime);
        } else if (value === "domain") {
          that.find('.value').html(self.domains_html);
          self.operators_html($html, self.operators.select);
        } else if (value === "sensor_name") {
          that.find('.value').html(self.sensors_html);
          self.operators_html($html, self.operators.select);
        } else if (value === "zone") {
          that.find('.value').html(self.zones_html);
          self.operators_html($html, self.operators.select);
        } else if (value == 'window') {
          that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="number" min="0" x-webkit-speech lang="en-US">');
          self.operators_html($html, self.operators.integer_input);
        } else {
          that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
          self.operators_html($html, self.operators.text_input);
        };

        that.find('.add_chosen').chosen({
          allow_single_deselect: false,
          width: "100%"
        });

        if (callback && (typeof callback === "function")) {
          callback(that);
        };

        that.trigger('rbsearch:search:change');
      });

      $('.search-content-box:first')
      .find('.search-content-remove')
      .css('opacity', 1)
      .unbind('hover')
      .unbind('mouseover');

      return $html;
    },

    remove: function(that) {
      var self = this;
      if ($('.search-content-box').length > 2) {
        $(that).parents('.search-content-box').remove();
      } else if ($('.search-content-box').length == 2) {
        $(that).parents('.search-content-box').remove();

        $('.search-content-box:first')
        .find('.search-content-remove')
        .css('opacity', 0.4)
        .attr('title', I18n.t('javascript.you_must'));
      };
    },

    pack: function(that) {
      var self = this;
      var matchAll = false;

      if ($('#search select.global-match-setting').val() === "all") {
        matchAll = true;
      };

      var json = {
        match_all: matchAll,
        items: {}
      };

      var fields = '.search-content-box'
      if (that && (typeof that === "string")) {
        fields = that;
      }

      $(fields).each(function(index, item) {
        var enabled = $(item).find('.search-content-enable input').is(':checked');
        var column = $(item).find('.column-select select').val();
        var operator = $(item).find('.operator-select select').val();
        var value = $(item).find('.value input, .value select').val();

        if (enabled){
          if (column == "start_time" || column == "end_time"){
            if ($(item).find('.value input').datetimepicker("getDate") == null) {
              alert(I18n.t('javascript.valid_date'));
              throw I18n.t('javascript.valid_date')
            }
            else{
              value = $(item).find('.value input').datetimepicker("getDate").getTime() / 1000;
              //value = new Date(value).getTime() / 1000; it doesn't work in Safari
          }
        }

          if ((column !== "") || (value !== "")) {
            json.items[index] = {
              column: column,
              operator: operator,
              value: value,
              enabled: enabled
            };
          };
        }
      });

      return json;
    },

    submit: function(callback, otherOptions) {
      var self = this;
      var search = self.pack();
      var csrf = $('meta[name="csrf-token"]').attr('content');

      if (typeof otherOptions !== "object") {
        otherOptions = {};
      };

      var update_url = function() {
        if (history && history.pushState) {
          history.pushState(null, document.title, '/filters/vault/advanced');
        };
      };

      if (callback && (typeof callback === "function")) {
        callback(search, self);
      };

      if (search && !$.isEmptyObject(search.items)) {
        if (otherOptions.search_id) {
          post_to_url('/filters/vault/advanced', {
            match_all: search.match_all,
            search: search.items,
            title: otherOptions.title,
            search_id: ""+otherOptions.search_id+"",
            authenticity_token: csrf
          });
        } else {
          post_to_url('/filters/vault/advanced', {
            match_all: search.match_all,
            search: search.items,
            authenticity_token: csrf
          });
        };
      } else {
        flash_message.push({type: 'error', message: I18n.t('javascript.you_cannot')});flash();
      };
    },

    build: function(search, where) {
      var self = this;

      if (typeof search === "string") {
        var data = JSON.parse(search);
      } else if (typeof search === "object") {
        var data = search;
      } else {
        var data = {};
      };

      if (data.items) {
       var rules = data.items;
      } else if (data.search) {
        var rules = data.search;
      } else {
        var rules = {};
      };

      if (data.match_all && data.match_all === "false") {
       $('select.global-match-setting option[value="any"]').prop('selected', 'selected');
      } else {
        $('select.global-match-setting option[value="all"]').prop('selected', 'selected');
      };

      for (id in rules) {
        var item = rules[id];

        var rule = (where !== undefined ? self.add(where) : self.add(false, {}));

        var column = rule.find('div.column-select select');

        rule.bind('rbsearch:search:change', function() {
          var operator = $(this).find('div.operator-select select');
          var value = $(this).find('div.value select, div.value input');

          operator.find("option[value='"+item.operator+"']").prop('selected', 'selected');
          operator.trigger("chosen:updated");

          if (item.column === "start_time" || item.column === "end_time") {
            if ($.isNumeric(item.value)) {
              date = new Date(item.value*1000);
            } else {
              date = new Date(Date.parse(item.value, "yyyy-MM-dd HH:mm"))
            }
            date_string = $.datepicker.formatDate( "yy-mm-dd", date);
            date_hours = date.getHours();
            date_minutes = date.getMinutes();

            if (date_hours < 10) { date_hours = "0" + date_hours; }
            if (date_minutes < 10) {date_minutes = "0" + date_minutes; }

            value.prop('value', date_string + " " + date_hours + ":" + date_minutes);
          } else {
            if (operator.val() == "empty" || operator.val() == "not_empty") {
              $(this).find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disabled x-webkit-speech lang="en-US">');
            }else {
              if ((item.column === "sensor_name" || item.column === "domain") && operator.val() == "contains") {
                $(this).find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disable x-webkit-speech lang="en-US">');
                var value = $(this).find('div.value select, div.value input');
              } else if (item.column === "sensor_name" || item.column === "domain") {
                var that = $(this).parents('.search-content-box');
                that.find('.value').html(self.sensors_html);
              } else if (item.column === 'zone') {
                var that = $(this).parents('.search-content-box');
                that.find('.value').html(self.zones_html);
              }
              value.prop('value', item.value);
            }

          }

          rule.unbind('rbsearch:search:change');
        });

        rule.attr('data-rule-id', id);

        column.find("option[value='"+item.column+"']").prop('selected','selected');
        column.trigger("chosen:updated").trigger('change');

        if (item.enabled === "false") {
          rule.find('div.search-content-enable input').prop('checked', false);
          rule.find('.value *, .operator-select *, .column-select *')
          .attr('disabled', true).css('opacity', 0.8);
        };
      };

      $('.rules .add_chosen').trigger("chosen:updated");
    },

  };

  return SearchVault;
}();

$(document).on('change', 'article#vault .operator-select .add_chosen', function(event, data) {
  var value = $(this).val();
  var that = $(this).parents('.search-content-box');
  var column = that.find('div.column-select select').val();

  if (value === "empty" || value === "not_empty") {
    that.find('.value').html('<input class="search-content-value" placeholder="" name="" type="text" disabled>');
  } else if (column == "sensor_name" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "sensor_name" && value != "contains") {
    that.find('.value').html(sensors_vault_html);
  } else if (column == "zone" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "zone" && value != "contains") {
    that.find('.value').html(zones_vault_html);
  } else if (column == "domain" && value == "contains") {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  } else if (column == "domain" && value != "contains") {
    that.find('.value').html(domain_vault_html);
  } else if (value == 'window') {
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="number" min="0" x-webkit-speech lang="en-US">');
  } else if (column != "start_time" && column != "end_time" && column != "domain" && column != "group_id" && column != "sensor_name"){
    that.find('.value').html('<input class="search-content-value" placeholder="' + I18n.t('javascript.enter_search') + '" name="" type="text" x-webkit-speech lang="en-US">');
  };

  that.find('.add_chosen').chosen({
    allow_single_deselect: false,
    width: "100%"
  });
});


function reloadRawIntervalVAULT (time) {
  var limit = time,
      n = limit;

  if (rbRawInterval !== undefined) {
    clearInterval(rbRawInterval);
    rbRawInterval = undefined;
  }

  rbRawInterval = setInterval(function () {
    if ($("body").hasClass("vault") && $("body").hasClass("index")) {
      $('li.reload a').html('<i class="fa fa-refresh"></i>' + (--n));

      if (n === 0) {
        n = limit;
        reloadRaw('vault');
      }
    } else {
      clearInterval(rbRawInterval);
      rbRawInterval = undefined;
    }
  }, 1000);

  $('li.reload-option a').text(I18n.t('javascript.stop_reloading'));
};

$(document).on('submit', 'article#tops_vault form.navbar-search.form-horizontal', function(e){
  var input_val = $(this).find('input.search-query').val();

  if(input_val.length < 1){
    e.preventDefault();
  }
});
