/*!    
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$('body.yara_policies.show li .row > .msg').on('click', function(e) {

  var policy_id = $('article#yara_rules').data('policy_id');

  var maltype = $(this).parents('li.maltype');
  var maltype = maltype.attr('data-maltype');
  var filetype_childs = $('li.filetype[data-maltype=' + maltype + ']');
  var all_childs = $('li[data-maltype=' + maltype + ']');
  var all_childs_loaded = $('li[data-maltype=' + maltype + '].load');

  if (maltype.hasClass('load') && maltype.hasClass('collapse-row')) {
    filetype_childs.show();
    maltype.removeClass('collapse-row');
    maltype.addClass('open');
    e.preventDefault();
    return false;
  } else if (maltype.hasClass('load')) {
    all_childs.not('li.maltype').hide();
    all_childs.removeClass('open');
    all_childs_loaded.addClass('collapse-row');
    maltype.removeClass('open').addClass('collapse-row');
    e.preventDefault();
    return false;
  }

  var url = '/yara_policies/' + policy_id + '/filetypes';

  $.ajax({
    url: url,
    remote: true,
    type: 'GET',
    data: {
      msg: "<%= params[:msg] %>",
      maltype: maltype
    }
  });
  
  return false;

});