#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

# not_activated = %w(
#   flow_hnbid flow_hnblocation flow_hnbgeolocation flow_imsi flow_apn flow_rat
#   flow_darklist_score_name flow_darklist_category flow_darklist_protocol
#   flow_darklist_direction flow_http_social_user flow_referer
#   flow_client_rssi flow_client_rssi_num flow_srv_port
# )

not_activated = %w(
  flow_hnbid flow_hnblocation flow_hnbgeolocation flow_imsi flow_apn flow_rat
  flow_http_social_user flow_referer flow_client_rssi flow_client_rssi_num flow_srv_port
)

Redborder::Module.get(:flow, :columns).keys.each do |col|
  col = "flow_#{col}"
  value = not_activated.include?(col) ? '0' : '1'
  Setting.where(name: col).first_or_create(name: col, value: value)
end

Redborder::Module.get(:flow, :overview_widgets).each do |w|
  setting_name = "overview_#{w[:partial]}"
  Setting.where(name: setting_name).first_or_create(name: setting_name, value: '1')
end

# Default Alarms
user = User.find_by(login: 'admin', admin: true) or User.first
Alarm.find_or_create_by(name: "Security: Darklist Category not clean detected in Traffic Event", condition: "{\"0\":{\"column\":\"darklist_category\",\"operator\":\"is_not\",\"value\":\"clean\",\"enabled\":true},\"1\":{\"column\":\"darklist_category\",\"operator\":\"not_empty\",\"value\":\"\",\"enabled\":true}}", enabled: true, interval: 3600, product_type: "flow", upper_limit: 1, time_window: 300, upper_limit_enabled: true, user_id: user.id, timezone: "UTC", aggregation: "bytes", multiplier_upper: 0, severity_id: 6, notify_to_syslog: false, notify_to_email: true, notify_to_slack: false, notify_to_vault: false, email_list: user.email)
