###############################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
###############################################################################

module RedBorder
  module WidgetsHelperMonitor
    def self.included(base)

      base.send(:include, InstanceMethods)

      base.class_eval do
        unloadable
        def more_info_url_monitor(widget)
          params = {}
          params[:range] = widget.range
          params[:search] = widget.filters if widget.filters
          params[:granularity] = widget.granularity if widget.granularity
          if widget.serie_type &&
             [:stacked, :area, :line, :sbars, :bars].include?(widget.serie_type.to_sym)
            params[:chart_type] = widget.serie_type
          end
          params[:category] = widget.category if widget.category

          '/monitor?' + params.to_query
        end

        def monitor_collection
          Redborder::Module.get(:monitor, :tabs)
            .each_with_object([]) do |(tab, hash), memo|
              hash[:name] = (hash[:name].to_s.start_with? "tr") ? (I18n.t(hash[:name].to_s[3..-1])) : (hash[:name])
              memo << [hash[:name], tab]
          end
        end

        def monitor_aggregations
          [['Average', :monitors], ['Sum', :sum]]
        end
      end
    end

    module InstanceMethods
    end
  end
end
