#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder

  module Jobs

    class ModelUpdatedbJob < Struct.new(:user_id, :verbose)
      
      include Redborder::Jobs::JobHelper

      def perform
        ModelSource.where(enable: true).update_all(updating: true)
        content = Redborder::ModelsUpdate.start(true)

      rescue Exception => e
        logit "#{e}"
        content += "#{e}\n"
      ensure
        ModelSource.all.update_all(updating: false)
        sources_names = ModelSource.where(enable: true).map(&:clean_name).join(', ')
        stored_job = StoredDelayedJob.create(user_id: user_id, job: "ModelUpdatedbJob", options: { humanize: sources_names }, content: content)
      end

    end

  end

end
