/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

redBorder.widgets.types.recent_malware = function (widget) {
  // This method return the first and last view of the element and the current
  // score.
  //
  // This query return a deferred object
  function queryRecent() {

    var data = {
      entries: widget.property.entries,
      range: widget.property.range
    };
    if(widget.property.min_score != "") data.min_score = widget.property.min_score;
    if(widget.property.sensor_type != "") data.sensor_type = widget.property.sensor_type;

    return $.ajax({
      url: "/malware/recent",
      type: 'GET',
      dataType: 'json',
      data: data
    });
  }

  return {
    queryRecent: queryRecent
  }
}
